      SUBROUTINE CDPRES(DEVAL,TEVAL,RCEVAL,
     +                  DDVAL,TDVAL,YDVAL,PDVAL)
 
C     *************************************************************************
C
C     CDPRES
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     30-AUG-2018:  CREATED
C     
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     COMPUTES DERIVATIVE OF PRESSURE
C     FROM EXISTING DERIVATIVES OF DENSITY, TEMPERATURE AND MASS FRACTION
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION YDVAL(NSPCMX)
      DOUBLE PRECISION DEVAL,TEVAL,RCEVAL
      DOUBLE PRECISION DDVAL,TDVAL,PDVAL


C     LOCAL DATA
C     ==========
      INTEGER ISPEC


C     BEGIN
C     =====

C     =========================================================================

      PDVAL = ZERO
      DO ISPEC = 1, NSPEC
        PDVAL = PDVAL + YDVAL(ISPEC)*RGSPEC(ISPEC)
      ENDDO
      PDVAL = PDVAL*DEVAL*TEVAL

      PDVAL = PDVAL + RCEVAL*(DDVAL*TEVAL + DEVAL*TDVAL)

C     =========================================================================


      RETURN
      END
