      SUBROUTINE DRFACT(NTDREF,NINDPR,NCDREF)
 
C     *************************************************************************
C
C     DRFACT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     10-APR-2009:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     CARRIES OUT DEREFINEMENT ACTIONS
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER NTDREF(NINDMX,NRDMAX)
      INTEGER NINDPR(NRDMAX)
      INTEGER NCDREF


C     LOCAL DATA
C     ==========
      INTEGER MCRUN(NINDMX)
      INTEGER JOCELL
      INTEGER ICDREF,ICBASE,IOFSET,INCODE


C     BEGIN
C     =====

C     =========================================================================

C     CARRY OUT THE DEREFINEMENT ACTIONS
C     ----------------------------------

C     RUN THROUGH THE OCTANTS
      DO ICDREF = 1,NCDREF,NOFSP1

C       NUMBER OF LOWEST CELL IN THE OCTANT
        ICBASE = NINDPR(ICDREF)

C       MARK LOWEST CELL FOR DEREFINEMENT
C       BY SETTING CELL REFINEMENT STATUS CODE
        NRSTAT(ICBASE) = NRDPAR

C       RUN THROUGH OTHER CELLS
        DO IOFSET = 1,NOFSET

C         NUMBER OF OTHER CELL
          JOCELL = NINDPR(ICDREF+IOFSET)

C         MARK OTHER CELL FOR DELETION
C         BY SETTING CELL REFINEMENT STATUS CODE
          NRSTAT(JOCELL) = NRDCHL

        ENDDO

C       NUMBER OF LOWEST M-CODE
        INCODE = ICBASE

C       UPDATE THE LOWEST CELL M-CODE BY LOWERING ITS LEVEL BY ONE
        CALL MCRTRV(MCRUN,NTDREF,NRDMAX,ICDREF)
        CALL MCLOWR(MCRUN)
        CALL MCSTOR(MCRUN,NMCODE,NSIZMX,INCODE)

      ENDDO

C     =========================================================================


      RETURN
      END
