      SUBROUTINE DRFGRC
 
C     *************************************************************************
C
C     DRFGRC
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     10-APR-2009:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     CARRIES OUT GARBAGE COLLECTION FOLLOWING DEREFINEMENT
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER NCNCEL(NSIZMX)
      INTEGER JCELL,JDEST
      INTEGER ICREFN

C     DIAGNOSTICS
      INTEGER LPROC


C     BEGIN
C     =====

C     DIAGNOSTICS
      LPROC = 20

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)WRITE(6,*)'In DRFGRC',ITIME

C     =========================================================================

C     GARBAGE COLLECTION
C     ------------------
      JDEST = 0

C     RIFFLE UP THE M-CODES
      DO JCELL = 1, NCELL

C       CHECK CELL REFINEMENT STATUS
        IF(NRSTAT(JCELL).NE.NRDCHL)THEN

          JDEST = JDEST + 1

C         OLD CELL INDEX LIST
C         LHC 08-MAY-2014
          NCOCEL(JDEST) = JCELL

C         NEW CELL INDEX LIST
C         LHC 08-MAY-2014
          NCNCEL(JCELL) = JDEST

          IF(JDEST.NE.JCELL)THEN

C           SHIFT UP THE M-CODE
            CALL MCMOVE(NMCODE,NSIZMX,JCELL,JDEST)

C           SHIFT UP THE CELL REFINEMENT STATUS
            NRSTAT(JDEST) = NRSTAT(JCELL)

          ENDIF

        ENDIF

      ENDDO

C     UPDATE THE HIGH WATER MARKS
      NNCODE = JDEST
      NCELL = JDEST

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)THEN
C        WRITE(6,'(I5)')NCELL
C        DO JCELL = 1, NCELL
C          JDEST = NCOCEL(JCELL)
C          WRITE(6,'(3I6)')JCELL,JDEST,NRSTAT(JCELL)
C        ENDDO
C      ENDIF

C     =========================================================================

C     UPDATE THE REFINEMENT LIST
      DO ICREFN = 1, N2REFN
        JCELL = NINDRR(ICREFN)
        JDEST = NCNCEL(JCELL)
        NINDRR(ICREFN) = JDEST
      ENDDO

C     =========================================================================

CC     REBUILD THE LOCAL OCTREE
CC     ------------------------
C      CALL RETREE
C      CALL RELEAF

C     =========================================================================


      RETURN
      END
