      SUBROUTINE ENTHPY(DLOCAL,TLOCAL,HLOCAL)

C     *************************************************************************
C
C     ENTHPY
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     12-MAR-2008:  CREATED
C     27-JAN-2011:  RSC UPDATED TO DO ALL SPECIES AT ONCE
C     30-SEP-2014:  RSC UPDATED FOR WENO
C     
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     COMPUTES SPECIES ENTHALPY
C     USING POLYNOMIAL DATA
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION HLOCAL(NSPCMX)
      DOUBLE PRECISION DLOCAL,TLOCAL


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION STORE1
      INTEGER ISPEC,ITINT,ICP


C     =========================================================================

C     BEGIN
C     =====

C     DENSITY INCLUDED FOR USE IN A MORE GENERAL EOS
C     PLACEHOLDER FOR NOW
      STORE1 = DLOCAL

C     =========================================================================

C     RUN THROUGH ALL SPECIES
      ITINT = 1
      DO ISPEC = 1, NSPEC

C       EVALUATE THE SPECIES ENTHALPIES
        STORE1 = AMASCH(NCPOLY(ITINT,ISPEC),ITINT,ISPEC)
        DO ICP = NCPOM1(ITINT,ISPEC),1,-1
          STORE1 = AMASCH(ICP,ITINT,ISPEC) + STORE1*TLOCAL
        ENDDO
        HLOCAL(ISPEC) = AMASCH(NCENTH(ITINT,ISPEC),ITINT,ISPEC)
     +                + STORE1*TLOCAL

      ENDDO
C     RUN THROUGH ALL SPECIES

C     =========================================================================


      RETURN
      END
