      SUBROUTINE ERHAND(IRNAME,IECODE,ISEVER)
 
C     *************************************************************************
C
C     ERHAND
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     28-MAY-2009:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     ERROR HANDLER
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER IRNAME,IECODE,ISEVER


C     LOCAL DATA
C     ==========
      INTEGER IRCODE,ISEVRR


C     BEGIN
C     =====

C     =========================================================================

C     SET INTERNAL VALUES OF ERROR AND SEVERITY CODES
      IRCODE = IECODE
      ISEVRR = ISEVER

C     =========================================================================

C     CHECK ERROR COUNTERS FROM PREVIOUS CALLS
      IF(JMINOR.GE.MMINOR)THEN
        ISEVRR = NFATAL
        IRCODE = 48
      ENDIF
      IF(JWARNN.GE.MWARNN)THEN
        ISEVRR = NFATAL
        IRCODE = 49
      ENDIF
      IF(JSEVER.GE.MSEVER)THEN
        ISEVRR = NFATAL
        IRCODE = 50
      ENDIF

C     =========================================================================

      IF(ISEVRR.EQ.NMINOR)THEN

C       -----------------------------------------------------------------------

C       MINOR ERROR
C       -----------
C       RECORD THE OCCURRENCE OF THE ERROR AND CARRY ON
        JMINOR = JMINOR + 1

C       -----------------------------------------------------------------------

      ELSEIF(ISEVRR.GT.NMINOR)THEN

C       -----------------------------------------------------------------------

C       MORE SEVERE ERROR
C       -----------------
C       OPEN THE REPORT FILE TO REPORT THE ERROR
        OPEN(UNIT=NCREPT,FILE=FNREPT,STATUS='OLD',FORM='FORMATTED')

C       GO TO EOF
1000    CONTINUE
          READ(NCREPT,'(A)',END=1010)
          GOTO 1000
C       END OF LOOP 1000

1010    BACKSPACE(NCREPT)

C       -----------------------------------------------------------------------

        IF(ISEVRR.EQ.NWARNN)THEN

C         ---------------------------------------------------------------------

C         WARNING
C         -------
          JWARNN = JWARNN + 1

          WRITE(NCREPT,9100)CRNAME(IRNAME),IPROC,CDEROR(IRCODE)
          WRITE(NCREPT,*)

C         -----------------------------------------------------------------------

        ELSEIF(ISEVRR.EQ.NSEVER)THEN

C         ---------------------------------------------------------------------

C         ERROR
C         -----
          JSEVER = JSEVER + 1

          WRITE(NCREPT,9200)CRNAME(IRNAME),IPROC,CDEROR(IRCODE)
          WRITE(NCREPT,*)

C         ---------------------------------------------------------------------

        ELSEIF(ISEVRR.EQ.NFATAL)THEN

C         ---------------------------------------------------------------------

C         FATAL ERROR
C         -----------
C         REPORT THE ERROR

C         STANDARD OUT
          WRITE(6,9300)CRNAME(IRNAME),IPROC,CDEROR(IRCODE)
          WRITE(6,*)

C         REPORT FILE
          WRITE(NCREPT,9300)CRNAME(IRNAME),IPROC,CDEROR(IRCODE)
          WRITE(NCREPT,*)

          WRITE(NCREPT,*)'hamish: abnormal termination of program'
          WRITE(NCREPT,*)'---------------------------------------'

C         ABORT ALL PROCESSES USING MPI
          CALL P_ABRT(IRCODE)
          CALL P_STOP
          STOP

C         ---------------------------------------------------------------------

        ENDIF

C       -----------------------------------------------------------------------

C       CLOSE THE REPORT FILE
        CLOSE(NCREPT)

      ENDIF

C     =========================================================================

C     FORMATS
9100  FORMAT('hamish: ',A6,': proc ',I5,': warning: ',A40)
9200  FORMAT('hamish: ',A6,': proc ',I5,': error: ',A40)
9300  FORMAT('hamish: ',A6,': proc ',I5,': fatal: ',A40)

C     ========================================================================r


      RETURN
      END
