      SUBROUTINE ADAPTM
 
C     *************************************************************************
C
C     ADAPTM
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     16-NOV-2008:  CREATED
C     25-APR-2015:  RSC REWRITTEN FOR WENO
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     ADAPTS THE SPATIAL MESH
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER N2RTOT,NGRTOT
C     DIAGNOSTICS
      INTEGER LPROC


C     BEGIN
C     =====

C     DIAGNOSTICS
      LPROC = 0

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)THEN
C        WRITE(6,'("In ADAPTM",2I5)')ITIME,NTMINT
C      ENDIF

C     =========================================================================

C     ADAPTION FLAG
C     -------------
      IF(FLADPM)THEN

C       =======================================================================

C       CHECK INTERVAL FOR ADAPTION
C       ---------------------------
        IF(MOD(ITIME,NTMINT).EQ.0)THEN

C         =====================================================================

C         PARALLEL TRANSFER
          CALL PARFER

C         EVALUATE DATA FOR REFINEMENT/DEREFINEMENT
          CALL REFDAT

C         CHECK LIMITS
          CALL ADMCHK

C         DEREFINE THE MESH
          IF(N2DREF.GT.0)CALL DEREFN

C         REFINE THE MESH
          IF(N2REFN.GT.0)CALL REFINE

C         DIAGNOSTICS
C          IF(IPROC.EQ.LPROC)THEN
C            WRITE(6,'("ADAPTM",2I5)')N2DREF,N2REFN
            IF((N2DREF.GT.0).OR.(N2REFN.GT.0))THEN
              WRITE(6,'("ADAPTM",4I8)')IPROC,ITIME,N2DREF,N2REFN
            ENDIF
C          ENDIF

C         HOUSEKEEPING
          N2RTOT = N2DREF + N2REFN
          CALL P_GMXI(N2RTOT,NGRTOT)

          IF(NGRTOT.GT.0)THEN

CC           DIAGNOSTICS
C            IF(IPROC.EQ.LPROC)WRITE(6,'("ADAPTM: call TREBAL")')

C           BALANCE THE OCTREE
            CALL TREBAL

C           UPDATE THE CELL VALUES
            CALL REFVAL

CC           DIAGNOSTICS
C            IF(IPROC.EQ.LPROC)WRITE(6,'("ADAPTM: call PARBAL")')

C           LOAD-BALANCE ACROSS PROCESSORS
            CALL PARBAL

CC           DIAGNOSTICS
C            IF(IPROC.EQ.LPROC)WRITE(6,'("ADAPTM: call STNCON")')

C           REBUILD MESH CONNECTIVITY
            CALL STNCON

          ENDIF

C         RESTORE VALUES
          CALL RESVAR

CC         DIAGNOSTICS
C          IF(IPROC.EQ.LPROC)WRITE(6,'("ADAPTM: end")')

C         =====================================================================

        ENDIF
C       CHECK INTERVAL FOR ADAPTION

C       =======================================================================

      ENDIF
C     ADAPTION FLAG

C     =========================================================================


      RETURN
      END
