C     HSIZES-------------------------------------------------------------------

C     MAX NUMBER OF PROCESSORS
      INTEGER NPROMX
      PARAMETER(NPROMX = 16)

C     MAX SIZE OF LOCAL ARRAYS
      INTEGER NSIZMX
      PARAMETER(NSIZMX = 1000000)

C     MAX SIZE OF BC DATA LISTS
      INTEGER NBCMAX
      PARAMETER(NBCMAX = 100000)

C     MAX SIZE OF REFINEMENT/DEREFINEMENT CELL LISTS
      INTEGER NRDMAX
      PARAMETER(NRDMAX = 200000)

C     MAX SIZE OF REMOTE CELL LISTS
      INTEGER NREMAX
      PARAMETER(NREMAX = 200000)

C     MAX SIZE OF PARALLEL TRANSFER ARRAY
      INTEGER NPARMX
      PARAMETER(NPARMX = 200000)

C     MAX SIZE OF PARALLEL TRANSFER HALO
      INTEGER NHALMX
      PARAMETER(NHALMX = 2)

C     MAX SIZE OF OCTREE ARRAY
C     NOTE: MIN VALUE = NSIZMX/8
      INTEGER NOCTMX
      PARAMETER(NOCTMX = 500000)

C     MAX NUMBER OF LEVELS IN OCTREE
      INTEGER NLEVMX
      PARAMETER(NLEVMX = 18)

C     MAX SIZE OF CELL INDEX CODES
      INTEGER NINDMX,NIOCMX,NIBTMX
      PARAMETER(NINDMX = 2, NIOCMX = 20, NIBTMX = 64)

C     MAX SIZE OF PARTITION INTERVAL TABLE
C     MIN VALUE: NTLSIZ = NINDMX*(NPROMX+1)
      INTEGER NTLSIZ
      PARAMETER(NTLSIZ = 34)

C     MAX NUMBER OF FACES, VELOCITY COMPONENTS
      INTEGER NFACMX,NCMPMX
      PARAMETER(NFACMX = 6, NCMPMX = 3)

C     MAX NO OF SPECIES
      INTEGER NSPCMX
      PARAMETER(NSPCMX = 18)

C     MAX SIZE OF CELL FACE HASH TABLE
      INTEGER NFCEMX
      PARAMETER(NFCEMX = 1000000)

C     HSIZES-------------------------------------------------------------------
C     CHEMIC-------------------------------------------------------------------

C     PARAMETERS
C     ==========
C     MAX NO OF REACTION STEPS
      INTEGER NSTPMX
      PARAMETER(NSTPMX = 68)

C     THERMODYNAMIC DATA
C     MAX NO OF TEMPERATURE INTERVALS, THERMO POLYNOMIAL COEFFICIENTS
      INTEGER NTINMX,NCOFMX
      PARAMETER(NTINMX = 2, NCOFMX = 7)
C     MAX NO OF TEMPERATURE COEFFICIENTS, DITTO MINUS ONE
      INTEGER NCTMAX,NCTMM1
      PARAMETER(NCTMAX = 5, NCTMM1 = NCTMAX-1)

C     CHEMICAL RATE DATA
C     MAX NO OF THIRD BODIES
      INTEGER NBDYMX
      PARAMETER(NBDYMX = 10)
C     MAX SIZE OF STEP SPECIES-LIST, STEP REACTANT-LIST
      INTEGER NSSMAX,NRSMAX
      PARAMETER(NSSMAX = 10, NRSMAX = 10)
C     MAX NO OF LINDEMANN STEPS
      INTEGER NLLMAX
      PARAMETER(NLLMAX = 10)

C     TRANSPORT COEFFICIENTS
      DOUBLE PRECISION ALAMDC,RLAMDA,TLAMDA
      PARAMETER(ALAMDC = 2.58D-5, RLAMDA = 7.0D-1, TLAMDA = 2.98D2)
      DOUBLE PRECISION PRANTL
      PARAMETER(PRANTL = 7.0D-1)

C     UNIVERSAL GAS CONSTANT
      DOUBLE PRECISION RGUNIV
      PARAMETER(RGUNIV = 8.3142D3)


C     CHEMICAL DATA
C     =============
      DOUBLE PRECISION AMOLCP(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMOLGB(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMASCP(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMASCT(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMASCH(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMASCS(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION TINTLO(NTINMX,NSPCMX),TINTHI(NTINMX,NSPCMX)
      DOUBLE PRECISION DIFFMU(NSSMAX,NSTPMX),DIFFMW(NSSMAX,NSTPMX)
      DOUBLE PRECISION CRSPEC(NSSMAX,NSTPMX),CPSPEC(NSSMAX,NSTPMX)
      DOUBLE PRECISION EFFY3B(NSPCMX,NBDYMX)
      DOUBLE PRECISION RPARAM(3,NSTPMX)
      DOUBLE PRECISION RCLIND(3,NLLMAX)
      DOUBLE PRECISION WMOLAR(NSPCMX),OVWMOL(NSPCMX),RGSPEC(NSPCMX)
      DOUBLE PRECISION CLEWIS(NSPCMX),OLEWIS(NSPCMX),OLEWPR(NSPCMX)
      DOUBLE PRECISION PREFGB,ALAMDA

      INTEGER NSSPEC(NSSMAX,NSTPMX)
      INTEGER NRSPEC(NSSMAX,NSTPMX),NPSPEC(NSSMAX,NSTPMX)
      INTEGER NRCPEC(NSSMAX,NSTPMX),NPCPEC(NSSMAX,NSTPMX)
      INTEGER NCOFCP(NTINMX,NSPCMX)
      INTEGER NCPOLY(NTINMX,NSPCMX),NCPOM1(NTINMX,NSPCMX)
      INTEGER NCENTH(NTINMX,NSPCMX),NCENPY(NTINMX,NSPCMX)
      INTEGER NSSLEN(NSTPMX)
      INTEGER NRSLEN(NSTPMX),NPSLEN(NSTPMX)
      INTEGER NRCLEN(NSTPMX),NPCLEN(NSTPMX)
      INTEGER MBLIST(NSTPMX)
      INTEGER MGLIST(NSTPMX)
      INTEGER MLLIST(NSTPMX)
      INTEGER NTINT(NSPCMX)
      INTEGER NSPM1,NBODY,NGIBB,NLIND
 
C     MAX LENGTH OF SPECIES SYMBOL STRINGS
      INTEGER NSPSTR
      PARAMETER(NSPSTR = 10)
C     SPECIES AND THIRD BODY STRINGS MUST BE DECLARED AS CHARACTER*NSPSTR
      CHARACTER*10 SPCSYM(NSPCMX)
      CHARACTER*10 BDYSYM(NSPCMX)

      COMMON/CHEMIC/AMOLCP,AMOLGB,AMASCP,AMASCT,AMASCH,AMASCS,
     +              TINTLO,TINTHI,
     +              DIFFMU,DIFFMW,CRSPEC,CPSPEC,EFFY3B,RPARAM,RCLIND,
     +              WMOLAR,OVWMOL,RGSPEC,CLEWIS,OLEWIS,OLEWPR,
     +              PREFGB,ALAMDA,
     +              NSSPEC,NRSPEC,NPSPEC,NRCPEC,NPCPEC,
     +              NCOFCP,NCPOLY,NCPOM1,NCENTH,NCENPY,
     +              NSSLEN,NRSLEN,NPSLEN,NRCLEN,NPCLEN,
     +              MBLIST,MGLIST,MLLIST,
     +              NTINT,
     +              NSPM1,NBODY,NGIBB,NLIND,
     +              SPCSYM,BDYSYM

C     CHEMIC-------------------------------------------------------------------
C     ACSIZE-------------------------------------------------------------------

C     ACTUAL SIZES
      INTEGER NPROC,NCELL,NLEVL,NFACE,NCOMP,NSPEC,NSTEP

      COMMON/ACSIZE/NPROC,NCELL,NLEVL,NFACE,NCOMP,NSPEC,NSTEP

C     ACSIZE-------------------------------------------------------------------
C     PARAMS-------------------------------------------------------------------

C     PHYSICAL AND NUMERICAL PARAMETERS

C     MAXIMUM INTEGER VALUE (32-BIT SIGNED INTEGER)
      INTEGER MAXINT
      PARAMETER(MAXINT = 2147483647)

C     MASS FRACTION TOLERANCE
      DOUBLE PRECISION YTOLER
      PARAMETER(YTOLER = 1.0E-10)

C     NUMBERS
      DOUBLE PRECISION ZERO,ONE,TWO,THREE,FOUR,SIX,
     +                 HALF,THRF,THRD,TTHD,FTHD,QRTR,SXTH,EIGHTH
      PARAMETER(ZERO=0.0D0, ONE=1.0D0, TWO=2.0D0, THREE=3.0D0,
     +          FOUR=4.0D0, SIX=6.0D0)
      PARAMETER(HALF=ONE/TWO,  THRF=THREE*HALF, THRD=ONE/THREE,
     +          TTHD=TWO*THRD, FTHD=TWO*TTHD,   QRTR=ONE/FOUR,
     +          SXTH=THRD/TWO, EIGHTH=QRTR*HALF)

C     FILE I/O UNIT NUMBERS
      INTEGER NCCONT,NCCHEM,NCBCIO,NCDMPI,NCDMPO,NCREPT,NCRESO,NCSTAT
      PARAMETER(NCCONT = 1, NCCHEM = 2, NCBCIO = 3, NCDMPI = 4,
     +          NCDMPO = 7, NCREPT = 8, NCRESO = 8, NCSTAT = 8)

C     RANDOM NUMBER GENERATOR STATUS ARRAY SIZES
      INTEGER NRNUMX,NRNGMX
      PARAMETER(NRNUMX = 100, NRNGMX = 102)

C     PHYSICAL AND NUMERICAL DATA
      DOUBLE PRECISION YRIN(NSPCMX)
      DOUBLE PRECISION PRIN,TRIN,SRIN,DRIN,URIN,VRIN,WRIN,ERIN
      DOUBLE PRECISION PREFER
      DOUBLE PRECISION UPRIME(NCMPMX)
      DOUBLE PRECISION XGDLEN,YGDLEN,ZGDLEN
      DOUBLE PRECISION XGPHYL,XGPHYR,YGPHYL,YGPHYR,ZGPHYL,ZGPHYR
      DOUBLE PRECISION OVPROC
      DOUBLE PRECISION RKTIME,ETIME,TSTEP
      DOUBLE PRECISION PI,TWOPI
      DOUBLE PRECISION RSIGN(NFACMX),RDELTA(NCMPMX,NCMPMX)
      DOUBLE PRECISION OFFSGN(NCMPMX,0:7)
      INTEGER MPMIN(NCMPMX,0:NLEVMX),MPMAX(NCMPMX,0:NLEVMX)
      INTEGER MATINC(NCMPMX,NFACMX)
      INTEGER MAPOPP(NFACMX)
      INTEGER MCFACE(2,4,NFACMX)
      INTEGER MCFCON(2,4)
      INTEGER MCQTBL(NFACMX,0:7)
      INTEGER MNGRAD(NCMPMX,0:7)
      INTEGER MCFTBL(NFACMX,4),MCFBLC(NFACMX,4)
      INTEGER MDIRN(NFACMX),MSIGN(NFACMX),MCSIGN(NFACMX)
      INTEGER MFACE(NCMPMX,2)
      INTEGER MNVIST(2,NCMPMX)
      INTEGER ICELL,ITIME,NTIME,NTIME1,NTIME2,NSTPSW,
     +        INTURB,INFLAM,ITSEED,
     +        NXGREQ,NLEVRQ,NSTMSW,NBLEVL,NSPREQ,NNCODE,NPRM1,
     +        NTDUMP,NDIFMT,NDOFMT,NROFMT,NTREPT,
     +        ITSTAT,NTSTAT,NTRESO,ICFLAG,IDFLAG,IDTIME,IRFLAG,
     +        NCONT1,NCONT2,NCONT3,NCONT4,NCONT5,NCONT6
      CHARACTER*80 FNCONT,FNCHEM,FNBCIO,FNREPT,FNRESO,FNSTAT,FNDMPO(2)
      CHARACTER*80 CLDASH,CLSTAR
      CHARACTER*6 FNPROC,FNFLAG
      CHARACTER*4 FNREST,FNXDAT,FNXRES
      LOGICAL FLHAND(NFACMX)
      LOGICAL FLADPT,FLADPM

      COMMON/PARAMS/
     +       YRIN,PRIN,TRIN,SRIN,DRIN,URIN,VRIN,WRIN,ERIN,
     +       PREFER,
     +       UPRIME,
     +       XGDLEN,YGDLEN,ZGDLEN,
     +       XGPHYL,XGPHYR,YGPHYL,YGPHYR,ZGPHYL,ZGPHYR,
     +       OVPROC,
     +       RKTIME,ETIME,TSTEP,PI,TWOPI,
     +       RSIGN,RDELTA,OFFSGN,
     +       MPMIN,MPMAX,
     +       MATINC,MAPOPP,MCFACE,MCFCON,MCQTBL,MNGRAD,MCFTBL,MCFBLC,
     +       MDIRN,MSIGN,MCSIGN,MFACE,MNVIST,
     +       ICELL,ITIME,NTIME,NTIME1,NTIME2,NSTPSW,
     +       INTURB,INFLAM,ITSEED,
     +       NXGREQ,NLEVRQ,NSTMSW,NBLEVL,NSPREQ,NNCODE,NPRM1,
     +       NTDUMP,NDIFMT,NDOFMT,NROFMT,NTREPT,
     +       ITSTAT,NTSTAT,NTRESO,ICFLAG,IDFLAG,IDTIME,IRFLAG,
     +       NCONT1,NCONT2,NCONT3,NCONT4,NCONT5,NCONT6,
     +       FNCONT,FNCHEM,FNBCIO,FNREPT,FNRESO,FNSTAT,FNDMPO,
     +       CLDASH,CLSTAR,
     +       FNPROC,FNFLAG,FNREST,FNXDAT,FNXRES,
     +       FLHAND,
     +       FLADPT,FLADPM

C     PARAMS-------------------------------------------------------------------
C     RUNKUT-------------------------------------------------------------------

C     RUNGE-KUTTA PARAMETERS
      INTEGER NRKMAX
      PARAMETER(NRKMAX = 3)

      DOUBLE PRECISION RKLHS(NRKMAX),RKRHS(NRKMAX)
      DOUBLE PRECISION RKERR(NRKMAX),RKTIM(NRKMAX)
      DOUBLE PRECISION RKLHC(NRKMAX),RKRHC(NRKMAX)
      DOUBLE PRECISION RKERC(NRKMAX),RKTMC(NRKMAX)
      DOUBLE PRECISION CTMULT,CTALPH,CTBETA,CTGAMA
      DOUBLE PRECISION ERRTOL,ERRLOW,TRMIN,TRMAX,TSMIN,TSMAX
      DOUBLE PRECISION ERROLD,ERRLDR
      DOUBLE PRECISION ERDTOT,ERUTOT,ERVTOT,ERWTOT,ERETOT
      DOUBLE PRECISION ERDNRM,ERUNRM,ERVNRM,ERWNRM,ERENRM
      DOUBLE PRECISION ERYTOT(NSPCMX),ERYNRM(NSPCMX)
      INTEGER IRKSTP,NRKSTP,NRKSM1
      INTEGER JERLOC,JINDIC

      COMMON/RUNKUT/RKLHS,RKRHS,RKERR,RKTIM,
     +              RKLHC,RKRHC,RKERC,RKTMC,
     +              CTMULT,CTALPH,CTBETA,CTGAMA,
     +              ERRTOL,ERRLOW,TRMIN,TRMAX,TSMIN,TSMAX,
     +              ERROLD,ERRLDR,
     +              ERDTOT,ERUTOT,ERVTOT,ERWTOT,ERETOT,ERYTOT,
     +              ERDNRM,ERUNRM,ERVNRM,ERWNRM,ERENRM,ERYNRM,
     +              IRKSTP,NRKSTP,NRKSM1,
     +              JERLOC,JINDIC

C     RUNKUT-------------------------------------------------------------------
C     PARDAT-------------------------------------------------------------------

C     PARALLEL TRANSFER ARRAY
      DOUBLE PRECISION PARRAY(NPARMX)

C     LOCAL PROCESSOR ID
      INTEGER IPROC

      COMMON/PARDAT/PARRAY,IPROC

C     PARDAT-------------------------------------------------------------------
C     PRVARS-------------------------------------------------------------------

C     PRINCIPAL VARIABLES
      DOUBLE PRECISION YRUN(NSPCMX,NSIZMX),
     +                 URUN(NCMPMX,NSIZMX),
     +                 DRUN(NSIZMX),ERUN(NSIZMX)
     
      COMMON/PRVARS/YRUN,URUN,DRUN,ERUN

C     PRVARS-------------------------------------------------------------------
C     TIMRHS-------------------------------------------------------------------

C     TIME-STEPPING RHS TERMS
      DOUBLE PRECISION YRHS(NSPCMX,NSIZMX),
     +                 URHS(NCMPMX,NSIZMX),
     +                 DRHS(NSIZMX),ERHS(NSIZMX)
     
      COMMON/TIMRHS/YRHS,URHS,DRHS,ERHS

C     TIMRHS-------------------------------------------------------------------
C     TIMERR-------------------------------------------------------------------

C     TIME-STEPPING ERROR ARRAYS
      DOUBLE PRECISION YERR(NSPCMX,NSIZMX),
     +                 UERR(NCMPMX,NSIZMX),
     +                 DERR(NSIZMX),EERR(NSIZMX)
     
      COMMON/TIMERR/YERR,UERR,DERR,EERR

C     TIMERR-------------------------------------------------------------------
C     PRIMVR-------------------------------------------------------------------

C     PRIMITIVE VARIABLES
      DOUBLE PRECISION YSOR(NSPCMX,NSIZMX),
     +                 RHOU(NCMPMX,NSIZMX),
     +                 USOR(NCMPMX,NSIZMX),
     +                 DSOR(NSIZMX),ESOR(NSIZMX)

      COMMON/PRIMVR/YSOR,RHOU,USOR,DSOR,ESOR

C     PRIMVR-------------------------------------------------------------------
C     SECVAR-------------------------------------------------------------------

C     SECONDARY VARIABLES
      DOUBLE PRECISION VGRAD1(NCMPMX,NSIZMX),VGRAD2(NCMPMX,NSIZMX),
     +                 SRUN(NSIZMX),PRUN(NSIZMX),TRUN(NSIZMX),
     +                 VISC(NSIZMX),COND(NSIZMX),
     +                 DIVU(NSIZMX)

      COMMON/SECVAR/VGRAD1,VGRAD2,SRUN,PRUN,TRUN,VISC,COND,DIVU

C     SECVAR-------------------------------------------------------------------
C     CELDAT-------------------------------------------------------------------

C     CELL STATUS PARAMETERS
      INTEGER NSBASE
      INTEGER NCLEAN,NCOUTR,NCHALO
      INTEGER N2HTOH,NHTO2H,NBCOND
      PARAMETER(NSBASE = 35)
      PARAMETER(NCLEAN = 0, NCOUTR = -1, NCHALO = -2) 
      PARAMETER(N2HTOH = 34, NHTO2H = 30, NBCOND = 1)

C     CELL FACE DISCRETISATION CODES
      INTEGER NDNULL,ND2PTC,ND3PTL,ND3PTR,ND4PTC
      PARAMETER(NDNULL = 0, ND2PTC = 1)
      PARAMETER(ND3PTL = 2, ND3PTR = 3, ND4PTC = 4) 

C     CELL FACE PARAMETERS
      INTEGER NFWEST,NFEAST,NFSUTH,NFNRTH,NFLOWR,NFUPPR
      PARAMETER(NFWEST = 1, NFEAST = 2,
     +          NFSUTH = 3, NFNRTH = 4,
     +          NFLOWR = 5, NFUPPR = 6)

C     CELL GLOBAL DATA
      DOUBLE PRECISION HCSIZE(0:NLEVMX),OVSIZE(0:NLEVMX)
      INTEGER NXDOOR(NFACMX,NSIZMX),NEFACE(NCMPMX,NSIZMX)
      INTEGER NMCODE(NINDMX,NSIZMX)
      INTEGER NSCODE(NSIZMX)
      INTEGER NDISCO(NSIZMX)
      INTEGER NPARNT(NSIZMX)
      INTEGER NLEVEL(NSIZMX)
      INTEGER NLVHWM

      COMMON/CELDAT/HCSIZE,OVSIZE,NXDOOR,NEFACE,
     +              NMCODE,NSCODE,NDISCO,NPARNT,NLEVEL,NLVHWM

C     CELDAT-------------------------------------------------------------------
C     REMOTE-------------------------------------------------------------------

C     REMOTE CELL DATA
      INTEGER NRCODE(NINDMX,NREMAX)
      INTEGER NRCLOC(NREMAX),NRRLOC(NREMAX)
      INTEGER N2SEND(NPROMX),N2RECV(NPROMX)
      INTEGER NCSEND(NPROMX),NCRECV(NPROMX)
      INTEGER NRCELL,NRRCEL

      INTEGER NXSEND(NPROMX),NXRECV(NPROMX)
      INTEGER NRCELX

      INTEGER NCELP1,NCELHW

C     PARTITION INTERVAL TABLE
      INTEGER NTABLE(NINDMX,0:NPROMX)

      COMMON/REMOTE/NRCODE,NRCLOC,NRRLOC,
     +              N2SEND,N2RECV,NCSEND,NCRECV,
     +              NRCELL,NRRCEL
      COMMON/RCINDX/NCELP1,NCELHW
      COMMON/REMEXT/NXSEND,NXRECV,NRCELX
      COMMON/PARTAB/NTABLE

C     REMOTE-------------------------------------------------------------------
C     CELFAC-------------------------------------------------------------------

C     CELL FACE DATA
      DOUBLE PRECISION YEFACE(NSPCMX,NFCEMX)
      DOUBLE PRECISION UEFACE(NCMPMX,NFCEMX)
      DOUBLE PRECISION DEFACE(NFCEMX),EEFACE(NFCEMX)
      INTEGER NFSTAK(NFCEMX)
      INTEGER ISTACK

      COMMON/CELFAC/YEFACE,UEFACE,DEFACE,EEFACE,NFSTAK,ISTACK

C     CELFAC-------------------------------------------------------------------
C     CELLOC-------------------------------------------------------------------

C     CELL LOCAL DATA
      DOUBLE PRECISION YFACE(NSPCMX,NFACMX)
      DOUBLE PRECISION UFACE(NCMPMX,NFACMX)
      DOUBLE PRECISION DFACE(NFACMX),EFACE(NFACMX)
      DOUBLE PRECISION YRATE(NSPCMX)
      DOUBLE PRECISION ERATE

      COMMON/CELLOC/YFACE,UFACE,DFACE,EFACE,YRATE,ERATE

C     CELLOC-------------------------------------------------------------------
C     CELREF-------------------------------------------------------------------

C     CELL REFINEMENT DATA
      DOUBLE PRECISION ERYREF(NSPCMX)
      DOUBLE PRECISION ERUREF(NCMPMX)
      DOUBLE PRECISION ERDREF,EREREF,ERPREF,ERTREF

      COMMON/CELREF/ERYREF,ERUREF,ERDREF,EREREF,ERPREF,ERTREF

      DOUBLE PRECISION ERYNRF(NSPCMX)
      DOUBLE PRECISION ERUNRF(NCMPMX)
      DOUBLE PRECISION ERDNRF,ERENRF,ERPNRF,ERTNRF

      COMMON/CELNRF/ERYNRF,ERUNRF,ERDNRF,ERENRF,ERPNRF,ERTNRF

C     CELREF-------------------------------------------------------------------
C     ESPCOM-------------------------------------------------------------------

C     COMMON DATA FOR TURBULENCE GENERATOR
C     ------------------------------------

C     GENERAL TURBULENCE PARAMETERS
C     -----------------------------
C     NUMBER OF TURBULENCE PARAMETERS
      INTEGER NSPARM
      PARAMETER(NSPARM = 7)

C     SPECTRUM PARAMETERS
      DOUBLE PRECISION SPARAM(NSPARM)

      COMMON/ESPCOM/SPARAM

C     ESPCOM-------------------------------------------------------------------
C     NSBCCP-------------------------------------------------------------------

C     BC TYPE PARAMETERS
      INTEGER NSNULL,NSPERI,
     +        NSBCI1,NSBCI2,NSBCI3,NSBCI4,
     +        NSBCO1,NSBCO2,NSBCO3,NSBCO4,
     +        NSBCW1,NSBCW2,NSBCW3,NSBCW4
      PARAMETER(NSNULL = 0,  NSPERI = 1,
     +          NSBCI1 = 11, NSBCI2 = 12, NSBCI3 = 13, NSBCI4 = 14,
     +          NSBCO1 = 21, NSBCO2 = 22, NSBCO3 = 23, NSBCO4 = 24,
     +          NSBCW1 = 25, NSBCW2 = 26, NSBCW3 = 27, NSBCW4 = 28)

C     BC NUMBER OF PARAMETERS
      INTEGER NBCPRI,NBCPRR
      PARAMETER(NBCPRI = 4, NBCPRR = 4)

C     GLOBAL BC TYPE VARIABLES
      INTEGER NGLOBC(NFACMX)
      
C     BC DATA
      DOUBLE PRECISION BCOORD(NCMPMX,NBCMAX)
      DOUBLE PRECISION RGBPRM(NBCPRR,NFACMX)
      DOUBLE PRECISION YBCSET(NSPCMX)
      DOUBLE PRECISION PBCINF(NFACMX),PBCNST(NFACMX)
      DOUBLE PRECISION DBCSET,TBCSET
      DOUBLE PRECISION UBCSET,UBCMAX,UBCFRQ,UBCPHA
      INTEGER NBCCEL(NBCMAX),NBCFAC(NBCMAX)
      INTEGER NGBPRM(NBCPRI,NFACMX)
      INTEGER NBCVAL
      COMMON/NSBCCP/BCOORD,RGBPRM,
     +              YBCSET,
     +              PBCINF,PBCNST,
     +              DBCSET,TBCSET,
     +              UBCSET,UBCMAX,UBCFRQ,UBCPHA,
     +              NBCCEL,NBCFAC,NGBPRM,NGLOBC,NBCVAL

C     TURBULENT INLET BC STORAGE SIZE PARAMETER
      INTEGER NBCSMX,NKINMX,NCINMX
      PARAMETER(NBCSMX = 1000, NKINMX = 50, NCINMX = 50)

C     TURBULENT INLET BC DATA
      DOUBLE PRECISION UBCSTO(NCMPMX,NBCSMX)
      DOUBLE PRECISION BINPRE(NCMPMX,NKINMX),BINMRE(NCMPMX,NKINMX)
      DOUBLE PRECISION BINPIM(NCMPMX,NKINMX),BINMIM(NCMPMX,NKINMX)
      DOUBLE PRECISION USUMRE(NCMPMX,NKINMX),UDIFRE(NCMPMX,NKINMX)
      DOUBLE PRECISION USUMIM(NCMPMX,NKINMX),UDIFIM(NCMPMX,NKINMX)
      DOUBLE PRECISION SCOS(NKINMX,NCINMX),SSIN(NKINMX,NCINMX)
      DOUBLE PRECISION UBCAVE(NCMPMX),UBCVAR(NCMPMX)
      DOUBLE PRECISION TOVRNK
      DOUBLE PRECISION GSIGMA,TINCOR,OMTCOR
      INTEGER KMLIST(2,NKINMX)
      INTEGER NKLIST
      INTEGER IBSEED
      INTEGER NBCAVE
      LOGICAL FBCSTO(NBCSMX)
      LOGICAL FLNTRB

      COMMON/NSBTRB/UBCSTO,
     +              BINPRE,BINMRE,BINPIM,BINMIM,
     +              USUMRE,UDIFRE,USUMIM,UDIFIM,
     +              SCOS,SSIN,
     +              UBCAVE,UBCVAR,
     +              TOVRNK,
     +              GSIGMA,TINCOR,OMTCOR,
     +              KMLIST,NKLIST,
     +              IBSEED,
     +              NBCAVE,
     +              FBCSTO,
     +              FLNTRB

C     NSBCCP-------------------------------------------------------------------
C     ERHNDL-------------------------------------------------------------------

C     MAX NUMBER OF ROUTINE NAMES
      INTEGER NCRNMX
      PARAMETER(NCRNMX = 32)

C     MAX NUMBER OF ERROR DESCRIPTIONS
      INTEGER NCRDMX
      PARAMETER(NCRDMX = 50)

C     ERROR SEVERITY CODES
      INTEGER NMINOR,NWARNN,NSEVER,NFATAL
      PARAMETER(NMINOR = 1, NWARNN = 2, NSEVER = 3, NFATAL = 4)

C     ERROR COUNTER MAX VALUES
      INTEGER MMINOR,MWARNN,MSEVER
      PARAMETER(MMINOR = 100, MWARNN = 20, MSEVER = 5)

C     ERROR COUNTERS
      INTEGER JMINOR,JWARNN,JSEVER

C     CALLING ROUTINE NAMES
      CHARACTER*6 CRNAME(NCRNMX)

C     ERROR DESCRIPTIONS
      CHARACTER*40 CDEROR(NCRDMX)

      COMMON/ERHNDL/JMINOR,JWARNN,JSEVER,CRNAME,CDEROR

C     ERHNDL-------------------------------------------------------------------
