      SUBROUTINE CONREP
 
C     *************************************************************************
C
C     CONREP
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT
C
C     CHANGE RECORD
C     -------------
C     05-OCT-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     REPORTS CONTROL DATA
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------

C     LOCAL DATA
C     ==========
      DOUBLE PRECISION FORNOW
      INTEGER IC,JSPEC
      

C     BEGIN
C     =====

C     =========================================================================

C     REPORT THE CONTROL DATA
C     =======================
     
      IF(IPROC.EQ.0)THEN

C       =======================================================================

C       OPEN THE REPORT FILE
        OPEN(UNIT=NCREPT,FILE=FNREPT,STATUS='OLD',FORM='FORMATTED')

C       GO TO EOF
1000    CONTINUE
          READ(NCREPT,'(A)',END=1010)
          GOTO 1000
C       END OF LOOP 1000

1010    BACKSPACE(NCREPT)

C       =======================================================================

C       CONTROL DATA HEADER
        WRITE(NCREPT,*)
        WRITE(NCREPT,*)'Control data:'
        WRITE(NCREPT,*)'------------'
        WRITE(NCREPT,*)

C       GLOBAL DOMAIN SIZE (x,y,z)
        WRITE(NCREPT,*)'Global domain size (x,y,z) in metres:'
        WRITE(NCREPT,9400)XGDLEN,YGDLEN,ZGDLEN
        WRITE(NCREPT,*)

C       GLOBAL BASE MESH SIZE
        WRITE(NCREPT,*)'Global cells (nx) initial, base/max levels:'
        WRITE(NCREPT,9100)NXGREQ,NLEVBQ,NLEVRQ
        WRITE(NCREPT,*)

C       NUMERICAL CONTROL
        WRITE(NCREPT,*)
     +    'Time step, start step, no of steps, step switch:'
        WRITE(NCREPT,9300)TSTEP,NTIME1,NTIME,NSTPSW
        WRITE(NCREPT,*)
        WRITE(NCREPT,*)
     + 'Intervals between dumps,reports,statistics, dump output format:'
        WRITE(NCREPT,9100)NTDUMP,NTREPT,NTSTAT,NDOFMT
        WRITE(NCREPT,*)

C       COLD START SWITCH
        WRITE(NCREPT,*)'Cold start switch, dump input format:'
        WRITE(NCREPT,9100)ICFLAG,NDIFMT
        WRITE(NCREPT,*)

C       INITIAL TURBULENCE GENERATOR 
        WRITE(NCREPT,*)'Initial turbulence generator'
        WRITE(NCREPT,*)
     + 'switch, random seed, turbulence parameters Rij, L:'
        WRITE(NCREPT,9200)INTURB,ITSEED,(SPARAM(IC),IC=1,NSPARM)
        WRITE(NCREPT,*)

C       FLAME START OPTION
        WRITE(NCREPT,*)'Mesh adaption switch, flame generator switch:'
        WRITE(NCREPT,9100)INMESH,INFLAM
        WRITE(NCREPT,*)

C       DEFAULT INITIAL DATA
        WRITE(NCREPT,*)'Default initial conditions'
        WRITE(NCREPT,*)'pressure, temperature, u,v,w, level set'
        WRITE(NCREPT,9400)PRIN,TRIN,URIN,VRIN,WRIN,SRIN
C       CHECK NUMBER OF SPECIES
        IF(NSPREQ.NE.NSPCMX)THEN
          WRITE(NCREPT,*)'Warning: INDATA: mismatch in no. of species'
          WRITE(NCREPT,*)'Global value:'
          WRITE(NCREPT,9100)NSPCMX
          WRITE(NCREPT,*)'Required value in control file:'
          WRITE(NCREPT,9100)NSPREQ
          WRITE(NCREPT,*)'Global value takes precedence'
          WRITE(NCREPT,*)
        ENDIF
        NSPEC = NSPCMX

C       INITIAL SPECIES MASS FRACTIONS
        WRITE(NCREPT,*)'species mass fractions'
        DO JSPEC = 1,NSPEC
          WRITE(NCREPT,9500)JSPEC,YRIN(JSPEC)
        ENDDO
C       CHECK INITIAL SPECIES MASS FRACTIONS
        FORNOW = ZERO
        DO JSPEC = 1,NSPEC
          FORNOW = FORNOW + YRIN(JSPEC)
        ENDDO
        IF(ABS(FORNOW-ONE).GT.YTOLER)THEN
          WRITE(NCREPT,*)
     +    'Warning: INDATA: initial mass fractions do not sum to unity'
          WRITE(NCREPT,*)
        ENDIF
        WRITE(NCREPT,*)

C       GLOBAL BOUNDARY CONDITION TYPES
        WRITE(NCREPT,*)'Global outer boundary condition types:'
        WRITE(NCREPT,*)'x-left,right, y-left,right, z-left,right'
        WRITE(NCREPT,9600)NGLOBC(1),(NGBPRM(IC,1),IC=1,NBCPRI),
     +                              (RGBPRM(IC,1),IC=1,NBCPRR)
        WRITE(NCREPT,9600)NGLOBC(2),(NGBPRM(IC,2),IC=1,NBCPRI),
     +                              (RGBPRM(IC,2),IC=1,NBCPRR)
        WRITE(NCREPT,9600)NGLOBC(3),(NGBPRM(IC,3),IC=1,NBCPRI),
     +                              (RGBPRM(IC,3),IC=1,NBCPRR)
        WRITE(NCREPT,9600)NGLOBC(4),(NGBPRM(IC,4),IC=1,NBCPRI),
     +                              (RGBPRM(IC,4),IC=1,NBCPRR)
        WRITE(NCREPT,9600)NGLOBC(5),(NGBPRM(IC,5),IC=1,NBCPRI),
     +                              (RGBPRM(IC,5),IC=1,NBCPRR)
        WRITE(NCREPT,9600)NGLOBC(6),(NGBPRM(IC,6),IC=1,NBCPRI),
     +                              (RGBPRM(IC,6),IC=1,NBCPRR)
        WRITE(NCREPT,*)

C       MESH REFINEMENT CRITERIA, INTERVAL,MIN/MAX LEVELS
        WRITE(NCREPT,*)
     + 'Mesh refinement/derefinement criteria, interval, min/max levels'
        WRITE(NCREPT,9390)DRETOL,DDETOL,NTMINT,NMLMIN,NMLMAX
        WRITE(NCREPT,*)

C       MESH REFINEMENT SCALING FACTORS
        WRITE(NCREPT,*)'Mesh refinement scaling factors'
        WRITE(NCREPT,*)'pressure, temperature, u,v,w, level set'
        WRITE(NCREPT,9400)SFREFD,SFREFT,SFREFU(1),SFREFU(2),SFREFU(3),
     +                    SFREFS
        WRITE(NCREPT,*)'species mass fractions'
        DO JSPEC = 1,NSPEC
          WRITE(NCREPT,9450)JSPEC,SFREFY(JSPEC)
        ENDDO
        WRITE(NCREPT,*)

        WRITE(NCREPT,*)'End of initial data'
        WRITE(NCREPT,*)'-------------------'
        WRITE(NCREPT,*)
        WRITE(NCREPT,9000)CLDASH

C       =======================================================================

C       CLOSE THE REPORT FILE
        CLOSE(NCREPT)

C       =======================================================================

      ENDIF

C     =========================================================================

C     END OF REPORTING OF CONTROL DATA

C     =========================================================================

      RETURN

C     FORMATS FOR OUTPUT OF INITIAL DATA
9000  FORMAT(A79)
9100  FORMAT(4I6)
9200  FORMAT(2I5,4(1PE12.4))
9300  FORMAT(1PE12.4,3I8)
9390  FORMAT(2(1PE12.4),3I8)
9400  FORMAT(6(1PE12.4))
9450  FORMAT(I7,1PE12.4)
9500  FORMAT(I7,1PE15.7)
9600  FORMAT(I5,2X,4I5,4(1PE12.4))

      END
