      SUBROUTINE CSTERM 
 
C     *************************************************************************
C
C     CSTERM
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     26-SEP-2014:  CREATED
C      
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     COMPUTES CELL SOURCE TERMS
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     PARAMETERS
C     ==========

C     LOCAL DATA
C     ==========
      DOUBLE PRECISION YEVAL(NSPCMX)
      DOUBLE PRECISION DEVAL,TEVAL
      DOUBLE PRECISION CCSIZE
      INTEGER JGPVOL,JSPEC,ILEVL


C     BEGIN
C     =====

C     =========================================================================

C     RUN THROUGH THE GAUSS POINTS
C     FOR VOLUME INTEGRATION
      DO JGPVOL = 1, NGPVOL

C       -----------------------------------------------------------------------

C       RETRIEVE GAUSS POINT VALUES
        DEVAL = DGVALS(JGPVOL)
        TEVAL = TGVALS(JGPVOL)
        DO JSPEC = 1, NSPEC
          YEVAL(JSPEC) = YGVALS(JSPEC,JGPVOL)
        ENDDO

C       -----------------------------------------------------------------------

C       SOURCE TERMS FOR MOMENTUM
        CALL UHRATE
  
C       -----------------------------------------------------------------------

C       SOURCE TERMS FOR ENERGY
        CALL EHRATE
  
C       -----------------------------------------------------------------------

C       SOURCE TERMS FOR SPECIES MASS FRACTION
C       CHEMICAL REACTION RATES
        CALL CHRATE(DEVAL,TEVAL,YEVAL)
  
C       -----------------------------------------------------------------------

      ENDDO

C     =========================================================================

C     SOURCE TERM SCALING
      ILEVL = NLEVEL(ICELL)
      CCSIZE = HCSIZE(ILEVL)
      URHS(1,ICELL) = URHS(1,ICELL)*CCSIZE
      URHS(2,ICELL) = URHS(2,ICELL)*CCSIZE
      URHS(3,ICELL) = URHS(3,ICELL)*CCSIZE
      ERHS(ICELL) = ERHS(ICELL)*CCSIZE
      DO JSPEC = 1, NSPEC
        YRHS(JSPEC,ICELL) = YRHS(JSPEC,ICELL)*CCSIZE
      ENDDO

C     =========================================================================


      RETURN
      END
