      SUBROUTINE ERINIT
 
C     *************************************************************************
C
C     ERINIT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     28-MAY-2009:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     INITIALISES THE ERROR HANDLER 
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     BEGIN
C     =====

C     =========================================================================

C     ERROR COUNTERS
      JMINOR = 0
      JWARNN = 0
      JSEVER = 0

C     =========================================================================

C     CALLING ROUTINE NAMES
      CRNAME(1) =  'PARDOM'
      CRNAME(2) =  'STNCON'
      CRNAME(3) =  'PARCEL'
      CRNAME(4) =  'RETREE'
      CRNAME(5) =  'TREBAL'
      CRNAME(6) =  'PARTRE'
      CRNAME(7) =  'STRAIN'
      CRNAME(8) =  'TEMPIN'
      CRNAME(9) =  'TEMPER'
      CRNAME(10) = 'STRABC'

      CRNAME(11) =  'RHSCEL'
      CRNAME(12) =  'CFLBCF'

      CRNAME(13) = 'BCINIT'
      CRNAME(14) = 'REFDAT'
      CRNAME(15) = 'REFCBC'
      CRNAME(16) = 'ADMCHK'
      CRNAME(17) = 'PARBIN'
      CRNAME(18) = 'PARBAL'
      CRNAME(19) = 'DISCON'
      CRNAME(20) = 'CFLUXF'
      CRNAME(21) = 'CF22HF'
      CRNAME(22) = 'CF2H2F'
      CRNAME(23) = 'CFLBCF'
      CRNAME(24) = 'DIFTRB'
      CRNAME(25) = 'DIFCBC'
      CRNAME(26) = 'unset'
      CRNAME(27) = 'unset'
      CRNAME(28) = 'unset'
      CRNAME(29) = 'unset'
      CRNAME(30) = 'unset'
      CRNAME(31) = 'unset'
      CRNAME(32) = 'unset'

C     =========================================================================

C     ERROR DESCRIPTIONS
      CDEROR(1) = 'local neighbour cell not found'
      CDEROR(2) = '2h-h extended cell not found'
      CDEROR(3) = 'interior cell not found'
      CDEROR(4) = 'periodic local cell not found'
      CDEROR(5) = 'periodic extended cell not found'
      CDEROR(6) = 'periodic cell not found'
      CDEROR(7) = 'invalid remote cell status code'

      CDEROR(8) = 'non-solvable cell'

      CDEROR(9) = 'lowest allowed cell code invalid'
      CDEROR(10) = 'error code unset'

      CDEROR(11) = 'received neighbour cell not found'
      CDEROR(12) = 'received 2h-h extended cell not found'
      CDEROR(13) = 'received cell not found'

      CDEROR(14) = 'error code unset'
      CDEROR(15) = 'error code unset'

      CDEROR(16) = 'remote cell code not found'

      CDEROR(17) = 'T upper limit failed to converge'
      CDEROR(18) = 'T lower limit failed to converge'
      CDEROR(19) = 'T iteration failed to converge'

      CDEROR(20) = 'load balancing failed to converge'

      CDEROR(21) = 'invalid cell face code - west'
      CDEROR(22) = 'invalid cell face code - east'
      CDEROR(23) = 'invalid cell face code - south'
      CDEROR(24) = 'invalid cell face code - north'
      CDEROR(25) = 'invalid cell face code - lower'
      CDEROR(26) = 'invalid cell face code - upper'
      CDEROR(27) = 'invalid cell face code'

      CDEROR(28) = 'invalid interpolation code'
      CDEROR(29) = 'error code unset'
      CDEROR(30) = 'error code unset'

      CDEROR(31) = 'invalid cell opposite-face code'
      CDEROR(32) = 'invalid boundary condition code'

      CDEROR(33) = 'invalid inlet boundary condition code'
      CDEROR(34) = 'error code unset'
      CDEROR(35) = 'error code unset'

      CDEROR(36) = 'too many cells to derefine'
      CDEROR(37) = 'too many cells to refine'
      CDEROR(38) = 'too many cells after refinement'
      CDEROR(39) = 'error code unset'
      CDEROR(40) = 'error code unset'
      CDEROR(41) = 'error code unset'
      CDEROR(42) = 'error code unset'
      CDEROR(43) = 'error code unset'
      CDEROR(44) = 'error code unset'
      CDEROR(45) = 'error code unset'
      CDEROR(46) = 'error code unset'
      CDEROR(47) = 'error code unset'

      CDEROR(48) = 'too many previous minor errors'
      CDEROR(49) = 'too many previous warnings'
      CDEROR(50) = 'too many previous errors'

C     ========================================================================r


      RETURN
      END
