      SUBROUTINE MCCOPL(MCODE1,MCODE2,NLEVEL)
 
C     *************************************************************************
C
C     MCCOPL
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     25-JUN-2008:  CREATED
C     15-MAY-2011:  REFORMULATED FOR IMPROVED PERFORMANCE
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     COPIES A MORTON CODE TO THE SPECIFIED LEVEL
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER MCODE1(MCSIZE),MCODE2(MCSIZE)
      INTEGER NLEVEL


C     LOCAL DATA
C     ==========
      INTEGER MLOCL(MCOCTS)
      INTEGER NPOCTS(MCSIZE)
      INTEGER MCCRUN
      INTEGER NLEVM1,MCSLVL,MCSLM1
      INTEGER ICSIZE,ICOCTS,IPOCTS


C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE
C     ----------
      NLEVM1 = NLEVEL - 1
      MCSLM1 = NLEVM1/NLOCTS
      DO ICSIZE = 1, MCSLM1
        NPOCTS(ICSIZE) = NLOCTS
      ENDDO
      MCSLVL = MCSLM1 + 1
      NPOCTS(MCSLVL) = NLEVEL - MCSLM1*NLOCTS

C     =========================================================================

C     CONVERT MORTON CODE TO OCTAL STRING
C     -----------------------------------
C     UP TO REQUIRED LEVEL ONLY
      ICOCTS = 0
      DO ICSIZE = 1, MCSLVL
        MCCRUN = MCODE1(ICSIZE)
        ICOCTS = ICOCTS + 1
        MLOCL(ICOCTS) = MOD(MCCRUN,8)
        DO IPOCTS = 2, NPOCTS(ICSIZE)
          MCCRUN = MCCRUN/8
          ICOCTS = ICOCTS + 1
          MLOCL(ICOCTS) = MOD(MCCRUN,8)
        ENDDO
      ENDDO

C     =========================================================================

C     CONVERT OCTAL STRING TO MORTON CODE
C     -----------------------------------
C     INITIALISE
      DO ICSIZE = 1, MCSIZE
        MCODE2(ICSIZE) = 0
      ENDDO

C     CONVERT
      ICOCTS = 0
      DO ICSIZE = 1, MCSLVL
        DO IPOCTS = 0, NPOCTS(ICSIZE)-1
          ICOCTS = ICOCTS + 1
          MCODE2(ICSIZE) = MCODE2(ICSIZE) + MLOCL(ICOCTS)*KCPWR8(IPOCTS)
        ENDDO
      ENDDO

C     =========================================================================

C     SET THE LEVEL CODE
      MCODE2(MCSIZE) = MCODE2(MCSIZE) + NLEVEL*KCPWR2(NLVBLO)

C     =========================================================================


      RETURN
      END
