      SUBROUTINE MCINCR(MCODE)
 
C     *************************************************************************
C
C     MCINCR
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     25-JUN-2008:  CREATED
C     15-MAY-2011:  REFORMULATED FOR IMPROVED PERFORMANCE
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     INCREMENTS A MORTON CODE BY ONE AT ITS OWN MAX LEVEL
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER MCODE(MCSIZE)


C     LOCAL DATA
C     ==========
      INTEGER MLOCL(MCOCTS)
      INTEGER NPOCTS(MCSIZE)
      INTEGER MCCRUN
      INTEGER NLEVEL
      INTEGER NLEVM1,MCSLVL,MCSLM1
      INTEGER ICSIZE,ICOCTS,IPOCTS


C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE
C     ----------
      NLEVEL = MCODE(MCSIZE)/KCPWR2(NLVBLO)
      NLEVM1 = NLEVEL - 1
      MCSLM1 = NLEVM1/NLOCTS
      DO ICSIZE = 1, MCSLM1
        NPOCTS(ICSIZE) = NLOCTS
      ENDDO
      MCSLVL = MCSLM1 + 1
      NPOCTS(MCSLVL) = NLEVEL - MCSLM1*NLOCTS

C     =========================================================================

C     CONVERT MORTON CODE TO OCTAL STRING
C     -----------------------------------
C     UP TO REQUIRED LEVEL ONLY
      ICOCTS = 0
      DO ICSIZE = 1, MCSLVL
        MCCRUN = MCODE(ICSIZE)
        ICOCTS = ICOCTS + 1
        MLOCL(ICOCTS) = MOD(MCCRUN,8)
        DO IPOCTS = 2, NPOCTS(ICSIZE)
          MCCRUN = MCCRUN/8
          ICOCTS = ICOCTS + 1
          MLOCL(ICOCTS) = MOD(MCCRUN,8)
        ENDDO
      ENDDO

C     =========================================================================

C     ADD ONE TO OCTAL STRING
C     -----------------------
C     WITH CARRY OPERATION
      ICOCTS = NLEVEL
1000  CONTINUE
        MLOCL(ICOCTS) = MLOCL(ICOCTS) + 1
        IF(MLOCL(ICOCTS).GE.8)THEN
          MLOCL(ICOCTS) = 0
          ICOCTS = ICOCTS - 1
          IF(ICOCTS.GE.1)GOTO 1000
        ENDIF
C     END OF LOOP 1000

C     =========================================================================

C     CONVERT OCTAL STRING TO MORTON CODE
C     -----------------------------------
      DO ICSIZE = 1, MCSIZE
        MCODE(ICSIZE) = 0
      ENDDO
      ICOCTS = 0
      DO ICSIZE = 1, MCSLVL
        DO IPOCTS = 0, NPOCTS(ICSIZE)-1
          ICOCTS = ICOCTS + 1
          MCODE(ICSIZE) = MCODE(ICSIZE) + MLOCL(ICOCTS)*KCPWR8(IPOCTS)
        ENDDO
      ENDDO

C     =========================================================================

C     SET THE LEVEL CODE
      MCODE(MCSIZE) = MCODE(MCSIZE) + NLEVEL*KCPWR2(NLVBLO)

C     =========================================================================


      RETURN
      END
