      SUBROUTINE MCSHFT(NMCODE,NMSIZE,PNCODE,IOFFST,IEND)

C     *************************************************************************
C
C     MCSHFT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     25-JUN-2008:  CREATED
C     15-MAY-2011:  REFORMULATED FOR IMPROVED PERFORMANCE
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     SHIFTS ALL MORTON CODES IN THE MAIN ARRAY
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER NMCODE(MCSIZE,NMSIZE)
      INTEGER NMSIZE,PNCODE,IOFFST,IEND


C     LOCAL DATA
C     ==========
      INTEGER ICODES,JCODES,ICSIZE


C     BEGIN
C     =====

C     =========================================================================

      IF(IOFFST.GT.0)THEN

        IF(IEND.LT.0)THEN

C         SHIFT LEFT
C         ----------
          DO ICODES = 1,PNCODE
            JCODES = ICODES + IOFFST
            DO ICSIZE = 1,MCSIZE
              NMCODE(ICSIZE,ICODES) = NMCODE(ICSIZE,JCODES)
            ENDDO
          ENDDO

        ELSE

C         SHIFT RIGHT
C         -----------
          DO ICODES = PNCODE,1,-1
            JCODES = ICODES + IOFFST
            DO ICSIZE = 1,MCSIZE
              NMCODE(ICSIZE,JCODES) = NMCODE(ICSIZE,ICODES)
            ENDDO
          ENDDO

        ENDIF

      ENDIF

C     =========================================================================


      RETURN
      END
