      PROGRAM MCTEST
 
C     *************************************************************************
C
C     MCTEST
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     25-JUN-2008:  CREATED
C     11-MAY-2011;  REVISED FOR REFORMULATED M-CODE LIBRARY
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     TEST HARNESS
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER MTCODE(MCSIZE),MBCODE(MCSIZE),MCCODE(MCSIZE)
      INTEGER MTLOCL(MCBITS),MBLOCL(MCBITS)
      INTEGER MVALUE,MOCTNT
      INTEGER NBLEVL
      INTEGER ICOCTS,ICBITS
      INTEGER ICSIZE
      INTEGER MX,MY,MZ
      INTEGER MLEVEL,MDIRN,MSIGN
 

C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE MCMLIB
C     -----------------
      CALL MCINIT

C     =========================================================================

C     TEST READING THE MORTON CODE INPUT FILE
      WRITE(6,*)'MCTEST: test reading the Morton code as a bit string'
      CALL MCREAD(MTCODE)
      WRITE(6,'(2I11)')(MTCODE(ICSIZE),ICSIZE=1,MCSIZE)

C     TEST WRITING THE BIT STRING
      WRITE(6,*)'MCTEST: test writing the bit string:'
      CALL MCRITE(MTCODE)
      WRITE(6,*)

C     =========================================================================
C
CC     TEST CONVERSION OF XYZ TO M-CODE
C      WRITE(6,*)'MCTEST: test conversion of xyz to M-code:'
C      NBLEVL = 12
C      MX = 3
C      MY = 5
C      MZ = 7
C      WRITE(6,*)MX,MY,MZ,NBLEVL
C      CALL MCXYZC(MBCODE,NBLEVL,MX,MY,MZ)
C      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
C      CALL MCRITE(MBCODE)
C      WRITE(6,*)
C
C     =========================================================================
C
CC     TEST CONVERSION OF M-CODE TO XYZ
C      WRITE(6,*)'MCTEST: test conversion of M-code to xyz:'
C      NBLEVL = 12
C      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
C      CALL MCRITE(MBCODE)
C      CALL MCCXYZ(MBCODE,NBLEVL,MX,MY,MZ)
C      WRITE(6,*)MX,MY,MZ,NBLEVL
C      WRITE(6,*)
C
C     =========================================================================

C     TEST CONVERSION OF XYZ TO M-CODE
      WRITE(6,*)'MCTEST: test conversion of xyz to M-code:'
      NBLEVL = 10
      MX = 513
      MY = 0
      MZ = 0
      WRITE(6,*)MX,MY,MZ,NBLEVL
      CALL MCXYZC(MBCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST CONVERSION OF M-CODE TO XYZ
      WRITE(6,*)'MCTEST: test conversion of M-code to xyz:'
      NBLEVL = 10
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      CALL MCCXYZ(MBCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,*)MX,MY,MZ,NBLEVL
      WRITE(6,*)

C     =========================================================================

C     TEST CONVERSION TO OCTAL STRING
      WRITE(6,*)'MCTEST: test conversion to octal string:'
      WRITE(6,'(2I11)')(MTCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MTCODE)
      CALL MCCI2O(MTCODE,MTLOCL)
      WRITE(6,*)NCOCTS
      WRITE(6,'(79I1)')(MTLOCL(ICOCTS),ICOCTS=1,NCOCTS)
      WRITE(6,*)

C     TEST CONVERSION OCTAL STRING TO MCODE
      WRITE(6,*)'MCTEST: test conversion octal string to Morton code'
      DO ICOCTS = 1,MCOCTS
        MBLOCL(ICOCTS) = MTLOCL(ICOCTS)
      ENDDO
      WRITE(6,'(79I1)')(MBLOCL(ICOCTS),ICOCTS=1,NCOCTS)
      CALL MCCO2I(MBCODE,MBLOCL)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      WRITE(6,*)
      CALL MCGLVL(MTCODE,NBLEVL)
      CALL MCPLVL(MBCODE,NBLEVL)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST CONVERSION TO BIT STRING
      WRITE(6,*)'MCTEST: test conversion to bit string:'
      WRITE(6,'(2I11)')(MTCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MTCODE)
      CALL MCCI2B(MTCODE,MTLOCL)
      WRITE(6,*)MCBITS
      WRITE(6,'(79I1)')(MTLOCL(ICBITS),ICBITS=1,MCBITS)
      WRITE(6,*)

C     TEST CONVERSION BIT STRING TO MCODE
      WRITE(6,*)'MCTEST: test conversion bit string to Morton code'
      DO ICBITS = 1,MCBITS
        MBLOCL(ICBITS) = MTLOCL(ICBITS)
      ENDDO
      WRITE(6,'(79I1)')(MBLOCL(ICBITS),ICBITS=1,MCBITS)
      CALL MCCB2I(MBCODE,MBLOCL)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      WRITE(6,*)
      CALL MCGLVL(MTCODE,NBLEVL)
      CALL MCPLVL(MBCODE,NBLEVL)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST INCREMENT OF M-CODE
      WRITE(6,*)'MCTEST: test increment of M-code:'
      DO ICSIZE = 1,MCSIZE
        MBCODE(ICSIZE) = MTCODE(ICSIZE)
      ENDDO
      NBLEVL = 12
      CALL MCRITE(MBCODE)
      CALL MCINCL(MBCODE,NBLEVL)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     WITH CARRY
      CALL MCREAD(MBCODE)
      NBLEVL = 12
      CALL MCRITE(MBCODE)
      CALL MCINCL(MBCODE,NBLEVL)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     WITH MULTIPLE CARRY
      CALL MCREAD(MBCODE)
      NBLEVL = 12
      CALL MCRITE(MBCODE)
      CALL MCINCL(MBCODE,NBLEVL)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     WITH CARRY TO LIMIT
      CALL MCREAD(MBCODE)
      NBLEVL = 12
      CALL MCRITE(MBCODE)
      CALL MCINCL(MBCODE,NBLEVL)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST INCREMENT OF ENTIRE M-CODE
      WRITE(6,*)'MCTEST: test increment of entire M-code:'
      DO ICSIZE = 1,MCSIZE
        MBCODE(ICSIZE) = MTCODE(ICSIZE)
      ENDDO
      CALL MCRITE(MBCODE)
      CALL MCINCR(MBCODE)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     ABOVE THE LOWER INTEGER
      CALL MCREAD(MCCODE)
      CALL MCRITE(MCCODE)
      CALL MCINCR(MCCODE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     WITH CARRY TO LIMIT
      CALL MCREAD(MCCODE)
      CALL MCRITE(MCCODE)
      CALL MCINCR(MCCODE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST DECREMENT OF M-CODE
      WRITE(6,*)'MCTEST: test decrement of M-code:'
      DO ICSIZE = 1,MCSIZE
        MBCODE(ICSIZE) = MTCODE(ICSIZE)
      ENDDO
      NBLEVL = 12
      CALL MCRITE(MBCODE)
      CALL MCDECL(MBCODE,NBLEVL)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     WITH CARRY
      CALL MCREAD(MBCODE)
      NBLEVL = 12
      CALL MCRITE(MBCODE)
      CALL MCDECL(MBCODE,NBLEVL)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     WITH MULTIPLE CARRY
      CALL MCREAD(MBCODE)
      NBLEVL = 12
      CALL MCRITE(MBCODE)
      CALL MCDECL(MBCODE,NBLEVL)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     WITH CARRY TO LIMIT
      CALL MCREAD(MBCODE)
      NBLEVL = 12
      CALL MCRITE(MBCODE)
      CALL MCDECL(MBCODE,NBLEVL)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST DECREMENT OF ENTIRE M-CODE
      WRITE(6,*)'MCTEST: test decrement of entire M-code:'
      DO ICSIZE = 1,MCSIZE
        MBCODE(ICSIZE) = MTCODE(ICSIZE)
      ENDDO
      CALL MCRITE(MBCODE)
      CALL MCDECR(MBCODE)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     ABOVE THE LOWER INTEGER
      CALL MCREAD(MCCODE)
      CALL MCRITE(MCCODE)
      CALL MCDECR(MCCODE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     WITH CARRY TO LIMIT
      CALL MCREAD(MCCODE)
      CALL MCRITE(MCCODE)
      CALL MCDECR(MCCODE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST COPYING OF M-CODE
      WRITE(6,*)'MCTEST: test copying of M-code:'
      DO ICSIZE = 1,MCSIZE
        MBCODE(ICSIZE) = MTCODE(ICSIZE)
      ENDDO
      NBLEVL = 12
      CALL MCRITE(MBCODE)
      CALL MCCOPL(MBCODE,MCCODE,NBLEVL)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

      NBLEVL = 5
      CALL MCRITE(MBCODE)
      CALL MCCOPL(MBCODE,MCCODE,NBLEVL)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST COPYING OF ENTIRE M-CODE
      WRITE(6,*)'MCTEST: test copying of entire M-code:'
      DO ICSIZE = 1,MCSIZE
        MBCODE(ICSIZE) = MTCODE(ICSIZE)
      ENDDO
      CALL MCRITE(MBCODE)
      CALL MCCOPY(MBCODE,MCCODE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST COMPARISON OF M-CODES
      WRITE(6,*)'MCTEST: test comparison of M-codes:'
      DO ICSIZE = 1,MCSIZE
        MBCODE(ICSIZE) = MTCODE(ICSIZE)
      ENDDO
      CALL MCREAD(MCCODE)

      NBLEVL = 12
      CALL MCRITE(MBCODE)
      CALL MCRITE(MCCODE)
      CALL MCCOML(MBCODE,MCCODE,NBLEVL,MVALUE)
      WRITE(6,*)MVALUE
      WRITE(6,*)

      NBLEVL = 12
      CALL MCRITE(MCCODE)
      CALL MCRITE(MBCODE)
      CALL MCCOML(MCCODE,MBCODE,NBLEVL,MVALUE)
      WRITE(6,*)MVALUE
      WRITE(6,*)

      NBLEVL = 11
      CALL MCRITE(MBCODE)
      CALL MCRITE(MCCODE)
      CALL MCCOML(MBCODE,MCCODE,NBLEVL,MVALUE)
      WRITE(6,*)MVALUE
      WRITE(6,*)

C     =========================================================================

C     TEST COMPARISON OF ENTIRE M-CODES
      WRITE(6,*)'MCTEST: test comparison of entire M-codes:'
      CALL MCREAD(MBCODE)
      CALL MCREAD(MCCODE)

      CALL MCRITE(MBCODE)
      CALL MCRITE(MCCODE)
      CALL MCCOMP(MBCODE,MCCODE,MVALUE)
      WRITE(6,*)MVALUE
      WRITE(6,*)

      CALL MCREAD(MBCODE)
      CALL MCREAD(MCCODE)

      CALL MCRITE(MCCODE)
      CALL MCRITE(MBCODE)
      CALL MCCOMP(MCCODE,MBCODE,MVALUE)
      WRITE(6,*)MVALUE
      WRITE(6,*)

      CALL MCREAD(MBCODE)
      CALL MCREAD(MCCODE)

      CALL MCRITE(MBCODE)
      CALL MCRITE(MCCODE)
      CALL MCCOMP(MBCODE,MCCODE,MVALUE)
      WRITE(6,*)MVALUE
      WRITE(6,*)

C     =========================================================================

C     TEST REDUCING THE LEVEL OF AN M-CODE
      WRITE(6,*)'MCTEST: test reducing the level of an M-code:'

      CALL MCREAD(MBCODE)
      CALL MCRITE(MBCODE)
      CALL MCLOWR(MBCODE)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST INCREASING THE LEVEL OF AN M-CODE
      WRITE(6,*)'MCTEST: test increasing the level of an M-code:'

      CALL MCRITE(MBCODE)
      CALL MCHIRE(MBCODE,7)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST EXTRACTION OF LEVEL CODE
      WRITE(6,*)'MCTEST: test extraction of level code'
      CALL MCRITE(MTCODE)
      CALL MCGLVL(MTCODE,MLEVEL)
      WRITE(6,*)MLEVEL
      WRITE(6,*)

C     TEST REPLACEMENT OF LEVEL CODE
      WRITE(6,*)'MCTEST: test replacement of level code'
      CALL MCCOPY(MTCODE,MBCODE)
      CALL MCRITE(MBCODE)
      MLEVEL = 5
      WRITE(6,*)MLEVEL
      CALL MCPLVL(MBCODE,MLEVEL)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     =========================================================================

C     TEST EXTRACTION OF OCTANT
      WRITE(6,*)'MCTEST: test extraction of octant'
      CALL MCREAD(MBCODE)
      CALL MCRITE(MBCODE)
      MLEVEL = 10
      CALL MCGOCT(MBCODE,MLEVEL,MOCTNT)
      WRITE(6,*)MLEVEL,MOCTNT
      WRITE(6,*)

C     TEST EXTRACTION OF OCTANT AT MAX LEVEL
      WRITE(6,*)'MCTEST: test extraction of octant at max level'
      CALL MCRITE(MBCODE)
      CALL MCGLVL(MBCODE,MLEVEL)
      CALL MCGOCR(MBCODE,MOCTNT)
      WRITE(6,*)MLEVEL,MOCTNT
      WRITE(6,*)

C     =========================================================================

C     TEST INCREMENT OF XYZ WITHIN M-CODE
      WRITE(6,*)'MCTEST: test increment of xyz within M-code:'
      WRITE(6,*)'MCTEST: original xyz:'
      NBLEVL = 10
      MX = 512
      MY = 1
      MZ = 1
      WRITE(6,*)MX,MY,MZ,NBLEVL
      CALL MCXYZC(MBCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      WRITE(6,*)

C     TEST CONVERSION TO BIT STRING
      WRITE(6,*)'MCTEST: test conversion to bit string:'
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      CALL MCCI2B(MBCODE,MTLOCL)
      WRITE(6,*)MCBITS
      WRITE(6,'(79I1)')(MTLOCL(ICBITS),ICBITS=1,MCBITS)
      WRITE(6,*)

C     TEST INCREMENT OF XYZ
      WRITE(6,*)'MCTEST: test increment of xyz:'
      NBLEVL = 10
      MDIRN = 1
      MSIGN = 1
      WRITE(6,*)MX,MY,MZ,NBLEVL,MDIRN,MSIGN
      CALL MCBINC(MBCODE,MTLOCL,NBLEVL,MDIRN,MSIGN)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      CALL MCCXYZ(MBCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,*)MX,MY,MZ,NBLEVL,MDIRN,MSIGN
      WRITE(6,*)

C     CHECK CONVERSION OF INCREMENTED XYZ TO M-CODE
      WRITE(6,*)'MCTEST: check conversion of incremented xyz to M-code:'
      NBLEVL = 10
      WRITE(6,*)MX,MY,MZ,NBLEVL
      CALL MCXYZC(MCCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,'(2I11)')(MCCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     TEST INCREMENT OF XYZ
      WRITE(6,*)'MCTEST: test increment of xyz:'
      NBLEVL = 10
      MDIRN = 2
      MSIGN = 1
      WRITE(6,*)MX,MY,MZ,NBLEVL,MDIRN,MSIGN
      CALL MCBINC(MBCODE,MTLOCL,NBLEVL,MDIRN,MSIGN)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      CALL MCCXYZ(MBCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,*)MX,MY,MZ,NBLEVL,MDIRN,MSIGN
      WRITE(6,*)

C     CHECK CONVERSION OF INCREMENTED XYZ TO M-CODE
      WRITE(6,*)'MCTEST: check conversion of incremented xyz to M-code:'
      NBLEVL = 10
      WRITE(6,*)MX,MY,MZ,NBLEVL
      CALL MCXYZC(MCCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,'(2I11)')(MCCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     TEST INCREMENT OF XYZ
      WRITE(6,*)'MCTEST: test increment of xyz:'
      NBLEVL = 10
      MDIRN = 3
      MSIGN = 1
      CALL MCBINC(MBCODE,MTLOCL,NBLEVL,MDIRN,MSIGN)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      CALL MCCXYZ(MBCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,*)MX,MY,MZ,NBLEVL,MDIRN,MSIGN
      WRITE(6,*)

C     CHECK CONVERSION OF INCREMENTED XYZ TO M-CODE
      WRITE(6,*)'MCTEST: check conversion of incremented xyz to M-code:'
      NBLEVL = 10
      WRITE(6,*)MX,MY,MZ,NBLEVL
      CALL MCXYZC(MCCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,'(2I11)')(MCCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     TEST INCREMENT OF XYZ
      WRITE(6,*)'MCTEST: test increment of xyz:'
      NBLEVL = 10
      MDIRN = 1
      MSIGN = -1
      WRITE(6,*)MX,MY,MZ,NBLEVL,MDIRN,MSIGN
      CALL MCBINC(MBCODE,MTLOCL,NBLEVL,MDIRN,MSIGN)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      CALL MCCXYZ(MBCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,*)MX,MY,MZ,NBLEVL,MDIRN,MSIGN
      WRITE(6,*)

C     CHECK CONVERSION OF INCREMENTED XYZ TO M-CODE
      WRITE(6,*)'MCTEST: check conversion of incremented xyz to M-code:'
      NBLEVL = 10
      WRITE(6,*)MX,MY,MZ,NBLEVL
      CALL MCXYZC(MCCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,'(2I11)')(MCCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     TEST INCREMENT OF XYZ
      WRITE(6,*)'MCTEST: test increment of xyz:'
      NBLEVL = 10
      MDIRN = 2
      MSIGN = -1
      WRITE(6,*)MX,MY,MZ,NBLEVL,MDIRN,MSIGN
      CALL MCBINC(MBCODE,MTLOCL,NBLEVL,MDIRN,MSIGN)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      CALL MCCXYZ(MBCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,*)MX,MY,MZ,NBLEVL,MDIRN,MSIGN
      WRITE(6,*)

C     CHECK CONVERSION OF INCREMENTED XYZ TO M-CODE
      WRITE(6,*)'MCTEST: check conversion of incremented xyz to M-code:'
      NBLEVL = 10
      WRITE(6,*)MX,MY,MZ,NBLEVL
      CALL MCXYZC(MCCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,'(2I11)')(MCCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     TEST INCREMENT OF XYZ
      WRITE(6,*)'MCTEST: test increment of xyz:'
      NBLEVL = 10
      MDIRN = 3
      MSIGN = -1
      CALL MCBINC(MBCODE,MTLOCL,NBLEVL,MDIRN,MSIGN)
      WRITE(6,'(2I11)')(MBCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MBCODE)
      CALL MCCXYZ(MBCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,*)MX,MY,MZ,NBLEVL,MDIRN,MSIGN
      WRITE(6,*)

C     CHECK CONVERSION OF INCREMENTED XYZ TO M-CODE
      WRITE(6,*)'MCTEST: check conversion of incremented xyz to M-code:'
      NBLEVL = 10
      WRITE(6,*)MX,MY,MZ,NBLEVL
      CALL MCXYZC(MCCODE,NBLEVL,MX,MY,MZ)
      WRITE(6,'(2I11)')(MCCODE(ICSIZE),ICSIZE=1,MCSIZE)
      CALL MCRITE(MCCODE)
      WRITE(6,*)

C     =========================================================================


      STOP
      END
