      SUBROUTINE OCSATT(NOCHLD,COCODE,NOCSIZ,
     +                  MCODE,CHATTR)
 
C     *************************************************************************
C
C     OCSATT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     21-JUN-2008:  CREATED
C     21-MAY-2011:  OCTAL STRING UPDATE
C     02-FEB-2016:  RSC MODIFIED FOR MULTIPLE OCTREES
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     SEARCHES THE LOCAL OCTREE USING A GIVEN MORTON CODE
C     SETS THE GIVEN ATTRIBUTE AT THE LEVEL SPECIFIED BY THE MORTON CODE
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_octlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER NOCSIZ
      INTEGER NOCHLD(0:7,NOCSIZ)
      INTEGER MCODE(NINDMX)
      CHARACTER*1 COCODE(0:7,NOCSIZ)
      CHARACTER*1 CHATTR


C     LOCAL DATA
C     ==========
      INTEGER MOCTAL(NIOCMX)
      INTEGER MLEVEL
      INTEGER IOCTNT,ILEVEL,ICHILD
      CHARACTER*1 CATTRB


C     BEGIN
C     =====

C     =========================================================================

C     CONVERT MORTON CODE TO OCTAL STRING
      CALL MCCI2O(MCODE,MOCTAL)

C     EXTRACT LEVEL
      CALL MCGLVL(MCODE,MLEVEL)

C     =========================================================================

C     MOVE UP THE OCTREE FROM THE ROOT
      IOCTNT = 1
      ILEVEL = 1
      ICHILD = MOCTAL(ILEVEL)
      CATTRB = COCODE(ICHILD,IOCTNT)
1000  CONTINUE
        IF(CATTRB.EQ.CHNRML)THEN
C         NORMAL BRANCH - CONTINUE THE SEARCH
          IF(ILEVEL.LT.MLEVEL)THEN
            IOCTNT = NOCHLD(ICHILD,IOCTNT)
            ILEVEL = ILEVEL + 1
            ICHILD = MOCTAL(ILEVEL)
            CATTRB = COCODE(ICHILD,IOCTNT)
            GOTO 1000
          ELSE
            COCODE(ICHILD,IOCTNT) = CHATTR
          ENDIF
        ELSEIF(CATTRB.EQ.CHTWIG)THEN
C         TWIG - CHILD IS A LEAF CONTAINING THE ADDRESS OF A CELL
          COCODE(ICHILD,IOCTNT) = CHATTR
        ELSEIF(CATTRB.EQ.CHOUTC)THEN
C         OUT - BRANCH IS OUTSIDE THE DOMAIN
          COCODE(ICHILD,IOCTNT) = CHATTR
        ELSEIF(CATTRB.EQ.CHPARL)THEN
C         PARALLEL - BRANCH IS ON A REMOTE PROCESSOR
          COCODE(ICHILD,IOCTNT) = CHATTR
        ELSEIF(CATTRB.EQ.CHUNST)THEN
C         UNSET - BRANCH HAS NOT YET GROWN
          COCODE(ICHILD,IOCTNT) = CHATTR
        ELSE
C         ERROR CONDITION
          CHATTR = CHEROR
        ENDIF
C     END OF LOOP 1000

C     =========================================================================


      RETURN
      END
