      SUBROUTINE OCTADL(NOCPAR,NOCHLD,COCODE,NOCSIZ,NOCHWM,
     +                  MCODE,NRLEVL,CHATTR)
 
C     *************************************************************************
C
C     OCTADL
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     31-AUG-2008:  CREATED
C     21-MAY-2011:  OCTAL STRING UPDATE
C     02-FEB-2016:  RSC MODIFIED FOR MULTIPLE OCTREES
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     ADDS A NEW OCTANT AT THE ADDRESS SPECIFIED BY THE GIVEN MORTON CODE
C     AT THE SPECIFIED LEVEL
C     SETS THE ATTRIBUTES OF ALL THE NEW BRANCHES TO THE SPECIFIED VALUE
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_octlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER NOCSIZ,NOCHWM
      INTEGER NRLEVL
      INTEGER NOCHLD(0:7,NOCSIZ)
      INTEGER NOCPAR(NOCSIZ)
      INTEGER MCODE(NINDMX)
      CHARACTER*1 COCODE(0:7,NOCSIZ)
      CHARACTER*1 CHATTR


C     LOCAL DATA
C     ==========
      INTEGER MOCTAL(NIOCMX)
      INTEGER IOCTNT,ILEVEL,ICHILD,IOCNEW,ICHNEW
      CHARACTER*1 CATTRB


C     BEGIN
C     =====

C     =========================================================================

C     CONVERT MORTON CODE TO OCTAL STRING
      CALL MCCI2O(MCODE,MOCTAL)

C     =========================================================================

C     MOVE UP THE OCTREE FROM THE ROOT
      IOCTNT = 1
      ILEVEL = 1
      ICHILD = MOCTAL(ILEVEL)
      CATTRB = COCODE(ICHILD,IOCTNT)
1000  CONTINUE
        IF(CATTRB.EQ.CHNRML)THEN
C         NORMAL BRANCH - CONTINUE THE SEARCH
          IF(ILEVEL.LT.NRLEVL)THEN
            IOCTNT = NOCHLD(ICHILD,IOCTNT)
            ILEVEL = ILEVEL + 1
            ICHILD = MOCTAL(ILEVEL)
            CATTRB = COCODE(ICHILD,IOCTNT)
            GOTO 1000
          ELSE
C           ERROR CONDITION
            CHATTR = CHEROR
          ENDIF
        ELSE
C         ADD A NEW OCTANT
          NOCHWM = NOCHWM + 1
          IOCNEW = NOCHWM
          NOCHLD(ICHILD,IOCTNT) = IOCNEW
          COCODE(ICHILD,IOCTNT) = CHNRML
          NOCPAR(IOCNEW) = IOCTNT
          DO ICHNEW = 0,7
            NOCHLD(ICHNEW,IOCNEW) = 0
            COCODE(ICHNEW,IOCNEW) = CHATTR
          ENDDO
        ENDIF
C     END OF LOOP 1000

C     =========================================================================


      RETURN
      END
