      SUBROUTINE PARFER
 
C     *************************************************************************
C
C     PARFER
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     28-SEP-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     CARRIES OUT TRANSFER OF PARALLEL DATA
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION PASEND(NREMAX),PARECV(NREMAX)
      INTEGER IRCELL,JCELL,JCOMP,JSPEC
C     DIAGNOSTICS
      INTEGER LPROC


C     BEGIN
C     =====

C     DIAGNOSTICS
      LPROC = 20


C     =========================================================================

C     EXCHANGE PARALLEL DATA
C     ----------------------

C     DIAGNOSTICS
      IF(IPROC.EQ.LPROC)THEN
        WRITE(6,'("PARFER",3I5)')IPROC
        DO IRCELL = 1,NPROC
          WRITE(6,'(3I5)')IRCELL,N2SEND(IRCELL),N2RECV(IRCELL)
        ENDDO
      ENDIF

C     DENSITY
      DO IRCELL = 1,NRRCEL
        JCELL = NRRLOC(IRCELL)

C       DIAGNOSTICS
        IF(IPROC.EQ.LPROC)THEN
          WRITE(6,'("PARFER RR",3I5)')IPROC,IRCELL,JCELL
        ENDIF

        PASEND(IRCELL) = DRHS(JCELL)
      ENDDO

      CALL P_A2AV(PASEND,NREMAX,N2SEND,NCSEND,
     +            PARECV,NREMAX,N2RECV,NCRECV,NPROC)

      DO IRCELL = 1,NRCELL
        JCELL = NRCLOC(IRCELL)

C       DIAGNOSTICS
        IF(IPROC.EQ.LPROC)THEN
          WRITE(6,'("PARFER RC",3I5)')IPROC,IRCELL,JCELL
        ENDIF

        DRHS(JCELL) = PARECV(IRCELL)
      ENDDO

C     VELOCITY
      DO JCOMP = 1,NCOMP

        DO IRCELL = 1,NRRCEL
          JCELL = NRRLOC(IRCELL)
          PASEND(IRCELL) = URHS(JCOMP,JCELL)
        ENDDO

        CALL P_A2AV(PASEND,NREMAX,N2SEND,NCSEND,
     +              PARECV,NREMAX,N2RECV,NCRECV,NPROC)

        DO IRCELL = 1,NRCELL
          JCELL = NRCLOC(IRCELL)
          URHS(JCOMP,JCELL) = PARECV(IRCELL)
        ENDDO

      ENDDO

C     INTERNAL ENERGY
      DO IRCELL = 1,NRRCEL
        JCELL = NRRLOC(IRCELL)
        PASEND(IRCELL) = ERHS(JCELL)
      ENDDO

      CALL P_A2AV(PASEND,NREMAX,N2SEND,NCSEND,
     +            PARECV,NREMAX,N2RECV,NCRECV,NPROC)

      DO IRCELL = 1,NRCELL
        JCELL = NRCLOC(IRCELL)
        ERHS(JCELL) = PARECV(IRCELL)
      ENDDO

C     SPECIES MASS FRACTIONS
      DO JSPEC = 1,NSPEC

        DO IRCELL = 1,NRRCEL
          JCELL = NRRLOC(IRCELL)

CC         DIAGNOSTICS
C          IF(IPROC.EQ.LPROC)THEN
C          WRITE(6,'("PARFER RR",4I5,1PE12.4)')IPROC,IRCELL,JCELL,JSPEC,
C     +                                          YRHS(JSPEC,JCELL)
C          ENDIF

          PASEND(IRCELL) = YRHS(JSPEC,JCELL)
        ENDDO

        CALL P_A2AV(PASEND,NREMAX,N2SEND,NCSEND,
     +              PARECV,NREMAX,N2RECV,NCRECV,NPROC)

        DO IRCELL = 1,NRCELL
          JCELL = NRCLOC(IRCELL)

CC         DIAGNOSTICS
C          IF(IPROC.EQ.LPROC)THEN
C          WRITE(6,'("PARFER RC",4I5,1PE12.4)')IPROC,IRCELL,JCELL,JSPEC,
C     +                                          YRHS(JSPEC,JCELL)
C          ENDIF

          YRHS(JSPEC,JCELL) = PARECV(IRCELL)
        ENDDO

      ENDDO

C     =========================================================================


      RETURN
      END
