      SUBROUTINE P_ATOA(A2SEND,NASEND,NISEND,A2RECV,NARECV,NIRECV)
 
C     *************************************************************************
C
C     P_ATOA
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     24-SEP-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     SENDS A DISTINCT MESSAGE TO EVERY OTHER PROCESS
C     RECEIVES A DISTINCT MESSAGE FROM EVERY OTHER PROCESS
C     USING MPI
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'mpif.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION A2SEND(NASEND),A2RECV(NARECV)
      INTEGER NASEND,NARECV
      INTEGER NISEND,NIRECV


C     LOCAL DATA
C     ==========
      INTEGER IERROR


C     BEGIN
C     =====

C     =========================================================================

      CALL MPI_ALLTOALL(A2SEND,NISEND,MPI_DOUBLE_PRECISION,
     +                  A2RECV,NIRECV,MPI_DOUBLE_PRECISION,
     +                  MPI_COMM_WORLD,IERROR)

C     =========================================================================


      RETURN
      END
