      SUBROUTINE REFINE
 
C     *************************************************************************
C
C     REFINE
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     16-NOV-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     REFINES THE SPATIAL MESH
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER NTREFN(NINDMX,NRDMAX)
      INTEGER NINDPR(NRDMAX)
      INTEGER MCRUN(NINDMX)
      INTEGER JCELL,ICREFN,NCREFN


C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE REFINEMENT CELL COUNTER
      ICREFN = 0

C     =========================================================================

C     LOOP OVER REFINEMENT LIST
C     -------------------------
      DO ICREFN = 1, N2REFN

C       RETRIEVE THE CORRESPONDING M-CODE
        JCELL = NINDRR(ICREFN)
        CALL MCRTRV(MCRUN,NMCODE,NSIZMX,JCELL)

C       STORE THE M-CODE AND THE CELL NUMBER
        CALL MCSTOR(MCRUN,NTREFN,NRDMAX,ICREFN)

C       LOCAL COPY OF REFINEMENT LIST
        NINDPR(ICREFN) = NINDRR(ICREFN)

      ENDDO
C     END OF LOOP OVER REFINEMENT LIST

C     NO OF CELLS TO REFINE
      NCREFN = N2REFN

C     =========================================================================

C     CARRY OUT THE REFINEMENT ACTIONS
C     --------------------------------
      CALL REFACT(NTREFN,NINDPR,NCREFN)

C     =========================================================================

C     GARBAGE COLLECTION FOLLOWING REFINEMENT
C     ------------------
      CALL REFGRC

C     =========================================================================


      RETURN
      END
