      SUBROUTINE REMDMI(MARRAY,NARRAY,NASIZE,N2SORT)
 
C     *************************************************************************
C
C     REMDMI
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     02-FEB-2016:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     REMOVES DUPLICATE ENTRIES FROM A SORTED ARRAY OF M-CODES
C     AND AN AUXILIARY ARRAY OF INTEGERS
C     WHERE BOTH THE M-CODE AND THE INTEGER ARE DUPLICATES
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER MARRAY(NINDMX,NASIZE),NARRAY(NASIZE)
      INTEGER NASIZE,N2SORT


C     LOCAL DATA
C     ==========
      INTEGER MCRUN(NINDMX),MCPRV(NINDMX)
      INTEGER JCELL,JCLM1,JDEST,NMCOMP


C     BEGIN
C     =====

C     =========================================================================

      IF(N2SORT.GT.1)THEN

C       =======================================================================

        JDEST = 1

        DO JCELL = 2, N2SORT

          JCLM1 = JCELL - 1
          CALL MCRTRV(MCPRV,MARRAY,NASIZE,JCLM1)
          CALL MCRTRV(MCRUN,MARRAY,NASIZE,JCELL)
          CALL MCCOMP(MCPRV,MCRUN,NMCOMP)
          IF(NMCOMP.NE.0)THEN

            JDEST = JDEST + 1

            IF(JDEST.NE.JCELL)THEN
              CALL MCMOVE(MARRAY,NASIZE,JCELL,JDEST)
              NARRAY(JDEST) = NARRAY(JCELL)
            ENDIF

          ELSE

            IF(NARRAY(JCELL).NE.NARRAY(JCLM1))THEN

              JDEST = JDEST + 1

              IF(JDEST.NE.JCELL)THEN
                CALL MCMOVE(MARRAY,NASIZE,JCELL,JDEST)
                NARRAY(JDEST) = NARRAY(JCELL)
              ENDIF

            ENDIF

          ENDIF

        ENDDO

C       =======================================================================

        N2SORT = JDEST

      ENDIF

C     =========================================================================


      RETURN
      END
