      SUBROUTINE RIEMAN(DEVALL,UEVALL,PEVALL,YEVALL,AEVALL,
     +                  DEVALR,UEVALR,PEVALR,YEVALR,AEVALR,
     +                  DEVALF,UEVALF,PEVALF,YEVALF,IDIRN)


C     *************************************************************************
C
C     RIEMAN
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     19-OCT-2014:  CREATED
C     
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     PRIMITIVE VARIABLE RIEMANN SOLVER
C     ASSUMES SUBSONIC FLOW
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION YEVALL(NSPCMX),YEVALR(NSPCMX),YEVALF(NSPCMX)
      DOUBLE PRECISION UEVALL(NCMPMX),UEVALR(NCMPMX),UEVALF(NCMPMX)
      DOUBLE PRECISION DEVALL,PEVALL,DEVALR,PEVALR,DEVALF,PEVALF
      INTEGER IDIRN


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION DLSTAR,DRSTAR
      DOUBLE PRECISION PESTAR,UESTAR
      DOUBLE PRECISION CHARCL,CHARCR,CHARSM,CHARMM
      DOUBLE PRECISION AEVALL,AEVALR
      DOUBLE PRECISION UEFACS,UEFACL,UEFACR
      INTEGER ISPEC


C     BEGIN
C     =====

C     =========================================================================

C     VALUES IN STAR REGION
C     ---------------------
      CHARCL = DEVALL*AEVALL
      CHARCR = DEVALR*AEVALR
      CHARSM = CHARCL + CHARCR
      CHARMM = CHARCL*CHARCR

      PESTAR = CHARCR*PEVALL + CHARCL*PEVALR
     +       + CHARMM*(UEVALL(IDIRN) - UEVALR(IDIRN))
      PESTAR = PESTAR/CHARSM

      UESTAR = CHARCL*UEVALL(IDIRN) + CHARCR*UEVALR(IDIRN)
     +       + PEVALL - PEVALR
      UESTAR = UESTAR/CHARSM

      DLSTAR = DEVALL + (PESTAR - PEVALL)/(AEVALL*AEVALL)
      DRSTAR = DEVALR + (PESTAR - PEVALR)/(AEVALR*AEVALR)

C     =========================================================================

C     SAMPLE THE SOLUTION
C     -------------------
      PEVALF = PESTAR

      UEFACS = SIGN(ONE,UESTAR)
      UEFACL = HALF*(ABS(UEFACS) + UEFACS)
      UEFACR = HALF*(ABS(UEFACS) - UEFACS)
      
      DEVALF = UEFACL*DLSTAR + UEFACR*DRSTAR

      UEVALF(1) = UEFACL*UEVALL(1) + UEFACR*UEVALR(1)
      UEVALF(2) = UEFACL*UEVALL(2) + UEFACR*UEVALR(2)
      UEVALF(3) = UEFACL*UEVALL(3) + UEFACR*UEVALR(3)
      UEVALF(IDIRN) = UESTAR
 
      DO ISPEC = 1, NSPEC
        YEVALF(ISPEC) = UEFACL*YEVALL(ISPEC) + UEFACR*YEVALR(ISPEC)
      ENDDO

C     =========================================================================


      RETURN
      END
