      SUBROUTINE RANGEB(STARAY)
 
C     *************************************************************************
C
C     RANGEB
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT
C
C     CHANGE RECORD
C     -------------
C     27-APR-2012:  CREATED
C
C     DESCRIPTION
C     -----------
C     GETS THE STATE OF UNIVARATE GAUSSIAN RANDOM NUMBER GENERATOR RANGAB
C     INCLUDES THE STATE OF UNIVARATE UNIFORM RANDOM NUMBER GENERATOR RANUNB
C     BASED ON NUMERICAL RECIPES ROUTINE 'RAN1'
C
C     REFERENCES
C     ----------
C     NUMERICAL RECIPES, 1st Ed, CUP (1986), pp195-199
C
C     *************************************************************************


C     PARAMETER
C     =========
      INTEGER NSTRMX
      PARAMETER(NSTRMX = 102)


C     ARGUMENT
C     ========
      DOUBLE PRECISION STARAY(NSTRMX)


C     SAVED DATA
C     ==========
      INTEGER NSHUFF
      PARAMETER(NSHUFF = 97)
      INTEGER INTX1,INTX2,INTX3
      DOUBLE PRECISION SHUFFL(NSHUFF)
      COMMON/RANCOB/SHUFFL,INTX1,INTX2,INTX3
      DOUBLE PRECISION RSAVED
      LOGICAL RREADY
      COMMON/GRANNB/RSAVED,RREADY


C     LOCAL DATA
C     ==========
      INTEGER IC


C     BEGIN
C     =====
      DO IC = 1,NSHUFF
        STARAY(IC) = SHUFFL(IC)
      ENDDO
      STARAY(NSHUFF+1) = REAL(INTX1)
      STARAY(NSHUFF+2) = REAL(INTX2)
      STARAY(NSHUFF+3) = REAL(INTX3)
      STARAY(NSHUFF+4) = RSAVED
      STARAY(NSHUFF+5) = 0.0D0
      IF(RREADY)STARAY(NSHUFF+5) = 1.0D0


      RETURN
      END
