      SUBROUTINE SORTIN(NARRAY,NASIZE,N2SORT)
 
C     *************************************************************************
C
C     SORTIN
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     27-AUG-2014:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     SORTS AN ARRAY OF INTEGERS
C     USING HEAPSORT
C
C     BASED ON NUMERICAL RECIPES pp229-232
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER NARRAY(NASIZE)
      INTEGER NASIZE,N2SORT


C     LOCAL DATA
C     ==========
      INTEGER NARTMP
      INTEGER NRTMP1,NRTMP2
      INTEGER IINDEX,JINDEX,JINDP1,KINDEX,LINDEX


C     BEGIN
C     =====

C     =========================================================================

C     PRELIMINARIES
C     -------------
      LINDEX = N2SORT/2 + 1

C     SORT ONLY IF ARRAY CONTAINS MORE THAN ONE ELEMENT
      IF(LINDEX.GT.1)THEN

C       =======================================================================

C       FORM THE HEAP
C       -------------
C       PICK A NEW ELEMENT FROM THE UPPER HALF OF THE HEAP
C                     I.E. FROM THE LOWER HALF OF THE ARRAY
1000    CONTINUE

          LINDEX = LINDEX - 1
          NARTMP = NARRAY(LINDEX)

          IINDEX = LINDEX
          JINDEX = LINDEX + LINDEX

C         LOOP TO SIFT THE NEW ELEMENT DOWN THE HEAP
1100      CONTINUE

            NRTMP1 = NARRAY(JINDEX)

C           FIND THE GREATER OF EACH PAIR OF EXISTING LOWER ELEMENTS
            IF(JINDEX.LT.N2SORT)THEN
              JINDP1 = JINDEX + 1
              NRTMP2 = NARRAY(JINDP1)
              IF(NRTMP1.LT.NRTMP2)THEN
                JINDEX = JINDP1
                NRTMP1 = NRTMP2
              ENDIF
            ENDIF

C           COMPARE THE NEW ELEMENT WITH THE EXISTING ELEMENT
            IF(NARTMP.LT.NRTMP1)THEN
              NARRAY(IINDEX) = NARRAY(JINDEX)
              IINDEX = JINDEX
              JINDEX = JINDEX + JINDEX
              IF(JINDEX.LE.N2SORT)GOTO 1100
            ENDIF

C         END OF LOOP 1100

C         PUT THE NEW ELEMENT INTO ITS SLOT
          NARRAY(IINDEX) = NARTMP

          IF(LINDEX.GT.1)GOTO 1000

C       END OF LOOP 1000

C       =======================================================================

C       SORT THE HEAP
C       -------------
        KINDEX = N2SORT

2000    CONTINUE

C         PICK THE HIGHEST UNSORTED ELEMENT OF THE ARRAY
          NARTMP = NARRAY(KINDEX)

C         MOVE THE CURRENT TOP-OF-THE-HEAP INTO THAT SLOT
          NARRAY(KINDEX) = NARRAY(1)

C         DECREMENT INDEX OF HIGHEST UNSORTED ELEMENT
          KINDEX = KINDEX - 1

C         CHECK FOR LOWEST ELEMENT
          IF(KINDEX.GT.1)THEN

C           NOT THE LOWEST ELEMENT
            IINDEX = 1
            JINDEX = 2

C           LOOP TO SIFT THE ELEMENT DOWN THE HEAP
2100        CONTINUE

              NRTMP1 = NARRAY(JINDEX)

C             FIND THE GREATER OF EACH PAIR OF EXISTING LOWER ELEMENTS
              IF(JINDEX.LT.KINDEX)THEN
                JINDP1 = JINDEX + 1
                NRTMP2 = NARRAY(JINDP1)
                IF(NRTMP1.LT.NRTMP2)THEN
                  JINDEX = JINDP1
                  NRTMP1 = NRTMP2
                ENDIF
              ENDIF

C             COMPARE THE NEW ELEMENT WITH THE EXISTING ELEMENT
              IF(NARTMP.LT.NRTMP1)THEN
                NARRAY(IINDEX) = NARRAY(JINDEX)
                IINDEX = JINDEX
                JINDEX = JINDEX + JINDEX
                IF(JINDEX.LE.KINDEX)GOTO 2100
              ENDIF

C           END OF LOOP 2100

C           PUT THE NEW ELEMENT INTO ITS SLOT
            NARRAY(IINDEX) = NARTMP
            GOTO 2000

          ELSE

C           LOWEST ELEMENT
            NARRAY(1) = NARTMP

          ENDIF

C       END OF LOOP 2000

C       =======================================================================

      ENDIF
C     END OF SORT ONLY IF ARRAY CONTAINS MORE THAN ONE ELEMENT

C     =========================================================================


      RETURN
      END
