      SUBROUTINE STINIT
 
C     *************************************************************************
C
C     STINIT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     08-JUL-2015:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     STENCIL CONNECTIVITY FOR POLYNOMIAL RECONSTRUCTION
C     CENTRAL STENCIL ONLY
C     RENO SCHEME
C     INITIALISATION
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------

C     LOCAL DATA
C     ==========
C      DOUBLE PRECISION RANGLE,COSRAN,SINRAN


C     BEGIN
C     =====

C     =========================================================================

C     RENO STENCIL CONSTRUCTION DATA
C     ------------------------------

C     NUMBERS OF POLYNOMIAL COEFFICIENTS
      NPCAC1 = 0
      NPCAC2 = 3
      NPCAC3 = 9
      NPCAC4 = 19

C     MIN REQUIRED NUMBER OF CELLS IN THE CENTRAL STENCIL
      NRQSTN = 20

C     MAX NUMBER OF LAYERS USED TO BUILD THE CENTRAL STENCIL
      NRQLAY = 5

C     NUMBER OF FACES FOR SECOND ORDER STENCIL
      N2FSTN = 6

C     TWO-DIMENSIONAL DOMAIN
      IF(NDIMS.EQ.2)THEN

C       NUMBERS OF POLYNOMIAL COEFFICIENTS
        NPCAC1 = 0
        NPCAC2 = 2
        NPCAC3 = 5
        NPCAC4 = 9

C       MIN REQUIRED NUMBER OF CELLS IN THE CENTRAL STENCIL
        NRQSTN = 11

C       MAX NUMBER OF LAYERS USED TO BUILD THE CENTRAL STENCIL
        NRQLAY = 5

C       NUMBER OF FACES FOR SECOND ORDER STENCIL
        N2FSTN = 4

      ENDIF

C     ONE-DIMENSIONAL DOMAIN
      IF(NDIMS.EQ.1)THEN

C       NUMBERS OF POLYNOMIAL COEFFICIENTS
        NPCAC1 = 0
        NPCAC2 = 1
        NPCAC3 = 2
        NPCAC4 = 3

C       MIN REQUIRED NUMBER OF CELLS IN THE CENTRAL STENCIL
        NRQSTN = 4

C       MAX NUMBER OF LAYERS USED TO BUILD THE CENTRAL STENCIL
        NRQLAY = 5

C       NUMBER OF FACES FOR SECOND ORDER STENCIL
        N2FSTN = 2

      ENDIF

C     =========================================================================
C
CC     WENO STENCIL CONSTRUCTION DATA
CC     ------------------------------
C
CC     ACTUAL AND MINIMUM-ALLOWED STENCIL SIZES
C
CC     ZEROTH DEGREE, FIRST ORDER
C      NPCAC1 = 0
C      NPCMN1 = 0
C
CC     FIRST DEGREE, SECOND ORDER
C      NPCAC2 = 3
C      NPCMN2 = 5
C
CC     SECOND DEGREE, THIRD ORDER
C      NPCAC3 = 9
C      NPCMN3 = 14
C
CC     THIRD DEGREE, FOURTH ORDER
C      NPCAC4 = 19
C      NPCMN4 = 29
C
C     =========================================================================
C
CC     AXIS ROTATION FOR SECTORAL STENCIL CONSTRUCTION
CC     -----------------------------------------------
C
CC     SMALL ANGLE FOR ROTATIONS ABOUT ALL THREE AXES
C      RANGLE = 1.0D-2
C
C      COSRAN = COS(RANGLE)
C      SINRAN = SIN(RANGLE)
C
C      XPAXIS(1) = COSRAN*COSRAN
C      XPAXIS(2) = COSRAN*SINRAN
C      XPAXIS(3) = -SINRAN
C
C      YPAXIS(1) = COSRAN*SINRAN*(SINRAN-ONE)
C      YPAXIS(2) = SINRAN*SINRAN*SINRAN + COSRAN*COSRAN
C      YPAXIS(3) = COSRAN*SINRAN
C
C      ZPAXIS(1) = SINRAN*(COSRAN*COSRAN + SINRAN)
C      ZPAXIS(2) = COSRAN*SINRAN*(SINRAN-ONE)
C      ZPAXIS(3) = COSRAN*COSRAN
C
C     =========================================================================


      RETURN
      END
