      SUBROUTINE MCCI2B(MCODE,MLOCL)
 
C     *************************************************************************
C
C     MCCI2B
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     22-MAY-2011:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     CONVERTS AN ENCODED INTEGER ARRAY INTO A BIT STRING
C     NOTE: LEVEL CODE IS NOt CONVERTED
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER MCODE(MCSIZE)
      INTEGER MLOCL(MCBITS)


C     LOCAL DATA
C     ==========
      INTEGER NPBITS(MCSIZE)
      INTEGER MCCRUN
      INTEGER NLEVEL
      INTEGER NLEVM1,MCSLVL,MCSLM1
      INTEGER ICSIZE,ICBITS,IPBITS


C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE
C     ----------
      NLEVEL = MCODE(MCSIZE)/KCPWR2(NLVBLO)
      NLEVM1 = NLEVEL - 1
      MCSLM1 =  NLEVM1/NLOCTS
      DO ICSIZE = 1, MCSLM1
        NPBITS(ICSIZE) = NLBITS
      ENDDO
      MCSLVL =  MCSLM1 + 1
      NPBITS(MCSLVL) = (NLEVEL - MCSLM1*NLOCTS)*3

C     =========================================================================

C     CONVERT MORTON CODE TO BIT STRING
C     ---------------------------------
C     UP TO REQUIRED LEVEL ONLY
      ICBITS = 0
      DO ICSIZE = 1, MCSLVL
        MCCRUN = MCODE(ICSIZE)
        ICBITS = ICBITS + 1
        MLOCL(ICBITS) = MOD(MCCRUN,2)
        DO IPBITS = 2, NPBITS(ICSIZE)
          MCCRUN = MCCRUN/2
          ICBITS = ICBITS + 1
          MLOCL(ICBITS) = MOD(MCCRUN,2)
        ENDDO
      ENDDO

C     FILL IN TO END OF STRING
      DO IPBITS = ICBITS+1, MCBITS
        MLOCL(IPBITS) = 0
      ENDDO

C     =========================================================================


      RETURN
      END
