      SUBROUTINE MCGOCR(MCODE,MOCTNT)
 
C     *************************************************************************
C
C     MCGOCR
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     05-SEP-2008:  CREATED
C     15-MAY-2011:  REFORMULATED FOR IMPROVED PERFORMANCE
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     GETS THE OCTANT FROM A MORTON CODE AT ITS OWN MAX LEVEL
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER MCODE(MCSIZE)
      INTEGER MOCTNT


C     LOCAL DATA
C     ==========
      INTEGER MLOCL(MCOCTS)
      INTEGER NPOCTS(MCSIZE)
      INTEGER MCCRUN
      INTEGER NLEVEL
      INTEGER NLEVM1,MCSLVL,MCSLM1
      INTEGER ICSIZE,ICOCTS,IPOCTS


C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE
C     ----------
      NLEVEL = MCODE(MCSIZE)/KCPWR2(NLVBLO)
      NLEVM1 = NLEVEL - 1
      MCSLM1 = NLEVM1/NLOCTS
      DO ICSIZE = 1, MCSLM1
        NPOCTS(ICSIZE) = NLOCTS
      ENDDO
      MCSLVL = MCSLM1 + 1
      NPOCTS(MCSLVL) = NLEVEL - MCSLM1*NLOCTS

C     =========================================================================

C     CONVERT MORTON CODE TO OCTAL STRING
C     -----------------------------------
C     UP TO REQUIRED LEVEL ONLY
      ICOCTS = 0
      DO ICSIZE = 1, MCSLVL
        MCCRUN = MCODE(ICSIZE)
        ICOCTS = ICOCTS + 1
        MLOCL(ICOCTS) = MOD(MCCRUN,8)
        DO IPOCTS = 2, NPOCTS(ICSIZE)
          MCCRUN = MCCRUN/8
          ICOCTS = ICOCTS + 1
          MLOCL(ICOCTS) = MOD(MCCRUN,8)
        ENDDO
      ENDDO

C     =========================================================================

C     EXTRACT OCTANT
C     --------------
      MOCTNT = MLOCL(NLEVEL)

C     =========================================================================


      RETURN
      END
