      SUBROUTINE MCRITE(MCODE)
 
C     *************************************************************************
C
C     MCRITE
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     25-JUN-2008:  CREATED
C     08-MAY-2011:  REFORMULATED FOR IMPROVED PERFORMANCE
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     WRITES AN MCODE TO STANDARD OUTPUT
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     PARAMETERS
C     ==========
      CHARACTER CDELIM
      PARAMETER(CDELIM = '!')


C     ARGUMENTS
C     =========
      INTEGER MCODE(1:MCSIZE)


C     LOCAL DATA
C     ==========
      INTEGER MLOCL(0:MCBITS)
      INTEGER MCCRUN
      INTEGER ICOUNT,ICOCTS,IC
      INTEGER ICSIZE,ICBITS,IPBITS,NLEVEL
      CHARACTER*79 CMCOUT
 
C     =========================================================================

C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE
C     ----------
C     BIT STRING
      DO ICBITS = 0,MCBITS
        MLOCL(ICBITS) = 0
      ENDDO

C     EXTRACT LEVEL CODE
      NLEVEL = MCODE(MCSIZE)/KCPWR2(NLVBLO)

C     =========================================================================

C     CONVERT MORTON CODE TO BIT STRING
C     ----------------------------------
      ICBITS = -1
      DO ICSIZE = 1, MCSIZE
        MCCRUN = MCODE(ICSIZE)
        ICBITS = ICBITS + 1
        MLOCL(ICBITS) = MOD(MCCRUN,2)
        DO IPBITS = 2,NIBITS(ICSIZE)
          MCCRUN = MCCRUN/2
          ICBITS = ICBITS + 1
          MLOCL(ICBITS) = MOD(MCCRUN,2)
        ENDDO
      ENDDO

C     =========================================================================

C     ADD IN THE LEVEL CODE
      ICBITS = NLGBLO
      MCCRUN = NLEVEL
      MLOCL(ICBITS) = MOD(MCCRUN,2)
      DO IPBITS = 2,NLVBTS
        MCCRUN = MCCRUN/2
        ICBITS = ICBITS + 1
        MLOCL(ICBITS) = MOD(MCCRUN,2)
      ENDDO

C     =========================================================================

C     WRITE OUT THE BIT STRING
C     FORMATTED
      ICOUNT = 0
      ICBITS = -1
      DO ICOCTS = 1,NMOCTS
        DO IC = 1,3
          ICOUNT = ICOUNT + 1
          ICBITS = ICBITS + 1
          WRITE(CMCOUT(ICOUNT:ICOUNT),'(I1)')MLOCL(ICBITS)
        ENDDO
        ICOUNT = ICOUNT + 1
        WRITE(CMCOUT(ICOUNT:ICOUNT),'(A1)')CDELIM
      ENDDO
      DO IC = 1,NLVBTS
        ICOUNT = ICOUNT + 1
        ICBITS = ICBITS + 1
        WRITE(CMCOUT(ICOUNT:ICOUNT),'(I1)')MLOCL(ICBITS)
      ENDDO
      WRITE(6,'(A)')CMCOUT(1:ICOUNT)

C     =========================================================================


      RETURN
      END
