      SUBROUTINE OUTPUT
 
C     *************************************************************************
C
C     OUTPUT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT - CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     11-JUN-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     PROCESSES THE RESULTS
C
C     FILES: REPORT FILE       - UNIT NCREPT - NAME FNREPT  - FORMATTED
C            DUMP OUTPUT FILES - UNIT NCDMPO - NAMES FNDMPO - UNFORMATTED
C            STATISTICS FILE   - UNIT NCSTAT - NAME FNSTAT  - FORMATTED
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     PARAMETERS
C     ==========
C     PLACEHOLDER: REQUIRED FOR DIAGNOSTICS
      DOUBLE PRECISION YSMALL
      PARAMETER(YSMALL = 1.0D-30)


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION TOUT(NSIZMX),POUT(NSIZMX)
      DOUBLE PRECISION RNSTAT(NRNGMX)
      INTEGER NCCRCV(NPROMX),NNCRCV(NPROMX)
      INTEGER NCTOTL,NRTOTL,FORNOW
      INTEGER JCELL,JSPEC,JPROC
      INTEGER IDREPT
      CHARACTER*4 PNFLAG

C     DIAGNOSTICS
      DOUBLE PRECISION XCOORD(NSIZMX),YCOORD(NSIZMX)
      INTEGER LPROC
      CHARACTER*40 FNDIAG
      CHARACTER*2 STRSPC

   
C     BEGIN
C     =====

C     DIAGNOSTICS
      LPROC = 0

C     =========================================================================

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)THEN
C        WRITE(6,*)'OUTPUT'
C        DO JCELL = 1, NCELL
C          WRITE(6,'(2I5)')JCELL
C          WRITE(6,'(4(1PE17.9))')DRUN(JCELL),
C     +             URUN(1,JCELL),URUN(2,JCELL),URUN(3,JCELL)
C          WRITE(6,'(4(1PE17.9))')DRHS(JCELL),
C     +             URHS(1,JCELL),URHS(2,JCELL),URHS(3,JCELL)
C          WRITE(6,'(4(1PE17.9))')ERUN(JCELL),TRUN(JCELL),
C     +             YRUN(1,JCELL),YRUN(2,JCELL)
C          WRITE(6,'(4(1PE17.9))')ERHS(JCELL),TRUN(JCELL),
C     +             YRHS(1,JCELL),YRHS(2,JCELL)
C        ENDDO
C      ENDIF

C     =========================================================================

C     FULL DUMP OUTPUT 
C     ================
      IF(MOD(ITIME,NTDUMP).EQ.0)THEN

C       CARRY OUT A FULL DUMP
C       ---------------------

C       SELECT DUMP FORMAT
        IF(NDOFMT.EQ.0)THEN

C         UNFORMATTED DUMP

C         USE THE DUMP FILE INDICATED BY IDFLAG
          OPEN(UNIT=NCDMPO,FILE=FNDMPO(IDFLAG+1),STATUS='OLD',
     +         FORM='UNFORMATTED')
          REWIND(NCDMPO)

          WRITE(NCDMPO)IPROC,NPROC
          WRITE(NCDMPO)XGPHYR,YGPHYR,ZGPHYR
          WRITE(NCDMPO)HCSIZE(0),NBLEVL,NLEVL,NCELL,NSPEC
          WRITE(NCDMPO)ETIME,TSTEP,ERROLD,ERRLDR
          WRITE(NCDMPO)(NLEVEL(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO)(XCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO)(YCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO)(ZCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO)(SRUN(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO)(DRUN(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO)(ERUN(JCELL),JCELL=1,NCELL)
C          WRITE(NCDMPO)(URUN(1,JCELL)-DRUN(JCELL)*URIN,JCELL=1,NCELL)
          WRITE(NCDMPO)(URUN(1,JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO)(URUN(2,JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO)(URUN(3,JCELL),JCELL=1,NCELL)
          DO JSPEC = 1,NSPEC
            WRITE(NCDMPO)(YRUN(JSPEC,JCELL),JCELL=1,NCELL)
          ENDDO

          CLOSE(NCDMPO)

        ELSE
 
C         FORMATTED DUMP

C         USE THE DUMP FILE INDICATED BY IDFLAG
          OPEN(UNIT=NCDMPO,FILE=FNDMPO(IDFLAG+1),STATUS='OLD',
     +         FORM='FORMATTED')
          REWIND(NCDMPO)

          WRITE(NCDMPO,*)IPROC,NPROC
          WRITE(NCDMPO,*)XGPHYR,YGPHYR,ZGPHYR
          WRITE(NCDMPO,*)HCSIZE(0),NBLEVL,NLEVL,NCELL,NSPEC
          WRITE(NCDMPO,*)ETIME,TSTEP,ERROLD,ERRLDR
          WRITE(NCDMPO,*)(NLEVEL(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO,*)(XCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO,*)(YCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO,*)(ZCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO,*)(SRUN(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO,*)(DRUN(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO,*)(ERUN(JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO,*)(URUN(1,JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO,*)(URUN(2,JCELL),JCELL=1,NCELL)
          WRITE(NCDMPO,*)(URUN(3,JCELL),JCELL=1,NCELL)
          DO JSPEC = 1,NSPEC
            WRITE(NCDMPO,*)(YRUN(JSPEC,JCELL),JCELL=1,NCELL)
          ENDDO

          CLOSE(NCDMPO)

        ENDIF

        IDTIME = ITIME
        IDREPT = IDFLAG
        IDFLAG = MOD(IDFLAG+1,2)

      ENDIF
C     FULL DUMP OUTPUT

C     =========================================================================

C     DUMP BC INFORMATION AS REQUIRED
C     ===============================
      IF(MOD(ITIME,NTDUMP).EQ.0)THEN

C       TURBULENT INLET VELOCITY DATA TO BC I/O FILE
        IF(FLNTRB)THEN

          IF(IPROC.EQ.0)THEN

C           SAVE THE STATUS OF THE GAUSSIAN RANDOM NUMBER GENERATOR
            CALL RANGEB(RNSTAT)

            OPEN(UNIT=NCBCIO,FILE=FNBCIO,FORM='UNFORMATTED')
            WRITE(NCBCIO)NKLIST
            WRITE(NCBCIO)KMLIST
            WRITE(NCBCIO)RNSTAT
            WRITE(NCBCIO)BINPRE
            WRITE(NCBCIO)BINPIM
            WRITE(NCBCIO)BINMRE
            WRITE(NCBCIO)BINMIM
            WRITE(NCBCIO)SCOS
            WRITE(NCBCIO)SSIN
            CLOSE(NCBCIO)

          ENDIF

        ENDIF

      ENDIF

C     =========================================================================

C     REPORT OUTPUT 
C     =============
      IF(MOD(ITIME,NTREPT).EQ.0)THEN

C       REPORT ON ONE PROCESSOR ONLY
C       ------
C       GATHER CELL INFO
        IF(FLADPM)THEN
          CALL P_GTHI(NCELL,1,NCCRCV,NPROMX)
          CALL P_GTHI(NRCELL,1,NNCRCV,NPROMX)
        ENDIF

        IF(IPROC.EQ.0)THEN

          OPEN(UNIT=NCREPT,FILE=FNREPT,STATUS='OLD',FORM='FORMATTED')

C         GO TO EOF
2000      CONTINUE
            READ(NCREPT,9000,END=2010)
            GOTO 2000
2010      BACKSPACE(NCREPT)

C         TIME STEP REPORT
          WRITE(NCREPT,9100)ITIME
          WRITE(NCREPT,9110)ETIME,TSTEP

          IF(IDTIME.GE.0)THEN

C           LATEST DUMP REPORT
            WRITE(NCREPT,9140)IDTIME,IDREPT
            IDTIME = -1

          ENDIF
          WRITE(NCREPT,*)

C         CELL REPORT
          IF(FLADPM)THEN
            WRITE(NCREPT,9120)
            NCTOTL = 0
            NRTOTL = 0
            DO JPROC = 1, NPROC
              WRITE(NCREPT,9130)JPROC-1,NCCRCV(JPROC),NNCRCV(JPROC)
              NCTOTL = NCTOTL + NCCRCV(JPROC)
              NRTOTL = NRTOTL + NNCRCV(JPROC)
            ENDDO
            IF(NPROC.GT.1)THEN
              WRITE(NCREPT,9132)
              WRITE(NCREPT,9135)NCTOTL,NRTOTL
            ENDIF
            WRITE(NCREPT,*)
            CLOSE(NCREPT)
          ENDIF

        ENDIF

      ENDIF
C     REPORT OUTPUT

C     =========================================================================
    
C     RESULTS OUTPUT 
C     ==============
      IF(MOD(ITIME,NTRESO).EQ.0)THEN

C       WRITE OUT THE RESULTS
C       ---------------------

C       CONSTRUCT RESULTS OUTPUT FILENAME
        WRITE(PNFLAG,'(I4.4)')IRFLAG
        FNRESO = FNREST//FNPROC//PNFLAG//FNXRES

C       COMPUTE TEMPERATURE AND PRESSURE FOR RESULTS OUTPUT
        CALL TEMPOP(TOUT,POUT)

C       DIAGNOSTICS FOR 1D TESTS
C       U-VELOCITY
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
          YCOORD(JCELL) = URUN(1,JCELL)/DRUN(JCELL)
        ENDDO
        FNDIAG = 'uvel'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8000    CONTINUE
          READ(9,'(A)',END=8001)
          GOTO 8000
8001    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

C       MASS FLUX
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
          YCOORD(JCELL) = URUN(1,JCELL)
        ENDDO
        FNDIAG = 'mass'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8006    CONTINUE
          READ(9,'(A)',END=8007)
          GOTO 8006
8007    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

C       V-VELOCITY
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
C          YCOORD(JCELL) = URUN(2,JCELL)/DRUN(JCELL)
          YCOORD(JCELL) = URUN(2,JCELL)
        ENDDO
        FNDIAG = 'vvel'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8002    CONTINUE
          READ(9,'(A)',END=8003)
          GOTO 8002
8003    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

C       W-VELOCITY
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
C          YCOORD(JCELL) = URUN(3,JCELL)/DRUN(JCELL)
          YCOORD(JCELL) = URUN(3,JCELL)
        ENDDO
        FNDIAG = 'wvel'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8004    CONTINUE
          READ(9,'(A)',END=8005)
          GOTO 8004
8005    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

C       PRESSURE
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
          YCOORD(JCELL) = POUT(JCELL)
        ENDDO
        FNDIAG = 'pres'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8010    CONTINUE
          READ(9,'(A)',END=8011)
          GOTO 8010
8011    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

C       TEMPERATURE
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
          YCOORD(JCELL) = TOUT(JCELL)
        ENDDO
        FNDIAG = 'temp'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8020    CONTINUE
          READ(9,'(A)',END=8021)
          GOTO 8020
8021    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

C       DENSITY
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
          YCOORD(JCELL) = DRUN(JCELL)
        ENDDO
        FNDIAG = 'dens'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8030    CONTINUE
          READ(9,'(A)',END=8031)
          GOTO 8030
8031    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

C       ENERGY
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
          YCOORD(JCELL) = ERUN(JCELL)/DRUN(JCELL)
        ENDDO
        FNDIAG = 'ener'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8040    CONTINUE
          READ(9,'(A)',END=8041)
          GOTO 8040
8041    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

C       ENTHALPY
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
          YCOORD(JCELL) = ERUN(JCELL)/DRUN(JCELL)
     +                  + (POUT(JCELL)+PREFER)/DRUN(JCELL)
        ENDDO
        FNDIAG = 'enth'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8045    CONTINUE
          READ(9,'(A)',END=8046)
          GOTO 8045
8046    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

C       SPECIES
        DO JSPEC = 1,NSPEC
          DO JCELL = 1,NCELL
            XCOORD(JCELL) = XCENTR(JCELL)
            YCOORD(JCELL) = YRUN(JSPEC,JCELL)/DRUN(JCELL)
          ENDDO
          WRITE(STRSPC,'(I2.2)')JSPEC
          FNDIAG = 'yf'//STRSPC//FNPROC//FNXRES
          OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8050      CONTINUE
            READ(9,'(A)',END=8051)
            GOTO 8050
8051      BACKSPACE(9)
          DO JCELL = 1,NCELL
            WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
          ENDDO
          WRITE(9,*)
          CLOSE(9)
        ENDDO

C       SPECIES ERROR
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
          YCOORD(JCELL) = ZERO
          DO JSPEC = 1,NSPEC
            YCOORD(JCELL) = YCOORD(JCELL)
     +                    + YRUN(JSPEC,JCELL)/DRUN(JCELL)
          ENDDO
          YCOORD(JCELL) = ONE - YCOORD(JCELL)
        ENDDO
        FNDIAG = 'yfer'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8047    CONTINUE
          READ(9,'(A)',END=8048)
          GOTO 8047
8048    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

C       CELL LEVEL
        DO JCELL = 1,NCELL
          XCOORD(JCELL) = XCENTR(JCELL)
          YCOORD(JCELL) = REAL(NLEVEL(JCELL))
        ENDDO
        FNDIAG = 'levl'//FNPROC//FNXRES
        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
8052    CONTINUE
          READ(9,'(A)',END=8053)
          GOTO 8052
8053    BACKSPACE(9)
        DO JCELL = 1,NCELL
          WRITE(9,'(2(1PE17.9))')XCOORD(JCELL),YCOORD(JCELL)
        ENDDO
        WRITE(9,*)
        CLOSE(9)

CC       CELL LEVEL
C        FNDIAG = 'levl'//FNPROC//FNXRES
C        OPEN(UNIT=9,FILE=FNDIAG,FORM='FORMATTED')
C8052    CONTINUE
C          READ(9,'(A)',END=8053)
C          GOTO 8052
C8053    BACKSPACE(9)
C        DO JCELL = 1,NCELL
C          WRITE(9,'(2(I5))')JCELL,NLEVEL(JCELL)
C        ENDDO
C        WRITE(9,*)
C        CLOSE(9)
C       GVN
        IF(.TRUE.) THEN
          DO JCELL = 1,NCELL
            FORNOW = NLEVEL(JCELL)
            SRUN(JCELL) = HCSIZE(FORNOW)
          ENDDO
        ENDIF

C       SELECT RESULTS OUTPUT FORMAT
        IF(NROFMT.EQ.0)THEN

C         UNFORMATTED OUTPUT

C         USE THE OUTPUT FILE INDICATED BY IDFLAG
          OPEN(UNIT=NCRESO,FILE=FNRESO,STATUS='NEW',FORM='UNFORMATTED')

          WRITE(NCRESO)IPROC,NPROC
          WRITE(NCRESO)XGPHYR,YGPHYR,ZGPHYR
          WRITE(NCRESO)HCSIZE(0),NBLEVL,NLEVL,NCELL,NSPEC
          WRITE(NCRESO)ETIME,TSTEP,ERROLD,ERRLDR
          WRITE(NCRESO)(NLEVEL(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(XCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(YCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(ZCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(SRUN(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(DRUN(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(ERUN(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(TOUT(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(POUT(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(URUN(1,JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(URUN(2,JCELL),JCELL=1,NCELL)
          WRITE(NCRESO)(URUN(3,JCELL),JCELL=1,NCELL)
          DO JSPEC = 1,NSPEC
            WRITE(NCRESO)(YRUN(JSPEC,JCELL),JCELL=1,NCELL)
          ENDDO

        ELSE
 
C         FORMATTED OUTPUT

C         USE THE OUTPUT FILE INDICATED BY IDFLAG
          OPEN(UNIT=NCRESO,FILE=FNRESO,STATUS='NEW',FORM='FORMATTED')

          WRITE(NCRESO,*)IPROC,NPROC
          WRITE(NCRESO,*)XGPHYR,YGPHYR,ZGPHYR
          WRITE(NCRESO,*)HCSIZE(0),NBLEVL,NLEVL,NCELL,NSPEC
          WRITE(NCRESO,*)ETIME,TSTEP,ERROLD,ERRLDR
          WRITE(NCRESO,*)(NLEVEL(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(XCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(YCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(ZCENTR(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(SRUN(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(DRUN(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(ERUN(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(TOUT(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(POUT(JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(URUN(1,JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(URUN(2,JCELL),JCELL=1,NCELL)
          WRITE(NCRESO,*)(URUN(3,JCELL),JCELL=1,NCELL)
          DO JSPEC = 1,NSPEC
            WRITE(NCRESO,*)(YRUN(JSPEC,JCELL),JCELL=1,NCELL)
          ENDDO

        ENDIF

        CLOSE(NCRESO)
        IRFLAG = IRFLAG + 1

      ENDIF
C     RESULTS OUTPUT

C     =========================================================================

C     STATISTICS ON THE FLY
C     =====================

C     STATISTICS MASTER SWITCH
C     ------------------------
      IF(NTSTAT.GE.0)THEN

C       =======================================================================

C       OUTPUT STATISTICS
C       =================

C       STATISTICS ON ONE PROCESSOR ONLY
C       ----------
        CALL P_SUMI(NCELL,NCTOTL)
        CALL P_SUMI(NRCELL,NRTOTL)

        IF(IPROC.EQ.0)THEN

          IF(MOD(ITIME,NTSTAT).EQ.0)THEN

            OPEN(UNIT=NCSTAT,FILE=FNSTAT,STATUS='OLD',FORM='FORMATTED')

C           GO TO EOF
3000        CONTINUE
              READ(NCSTAT,9200,END=3010)
              GOTO 3000
3010        BACKSPACE(NCSTAT)

            WRITE(NCSTAT,*)ITIME,TSTEP,NCTOTL,NRTOTL

            CLOSE(NCSTAT)

          ENDIF       

        ENDIF       

C       RESET STORAGE INDEX
        ITSTAT = 0
 
C       =======================================================================

      ENDIF
C     STATISTICS MASTER SWITCH

C     =========================================================================

C     TIME STEP HISTORY
      IF(IPROC.EQ.0)THEN
        WRITE(10,'(I7,1PE12.4,2I7)')ITIME,TSTEP,JINDIC,JERLOC
      ENDIF

C     ========================================================================= 


      RETURN

9000  FORMAT(A)
9100  FORMAT('Time step number: ',I7)
9110  FORMAT('Elapsed time: ',1PE12.4,';',2X,'next time step:',1PE12.4)
9120  FORMAT('   Processor  No of cells  No of remote cells')
9130  FORMAT(I8,8X,I7,8X,I7)
9132  FORMAT(8X,8X,'-------',8X,'-------')
9135  FORMAT(8X,8X,I7,8X,I7)
9140  FORMAT('Latest dump at t-step: ',I7,'; dump ID: ',I5)
9200  FORMAT(I5,/
     +       5X,6(1PE12.4)/
     +       5X,6(1PE12.4)/
     +       5X,6(1PE12.4)/
     +       5X,4(1PE12.4)/
     +       5X,3(1PE12.4)/
     +       5X,3(1PE12.4)/
     +       5X,3(1PE12.4)/
     +       5X,3(1PE12.4)/
     +       5X,3(1PE12.4)/
     +       5X,2(1PE12.4))

      END
