      SUBROUTINE P_A2AV(A2SEND,NASEND,NISEND,NDSEND,
     +                  A2RECV,NARECV,NIRECV,NDRECV,
     +                  NGROUP)
 
C     *************************************************************************
C
C     P_A2AV
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     24-SEP-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     SENDS A DISTINCT MESSAGE TO EVERY OTHER PROCESS
C     RECEIVES A DISTINCT MESSAGE FROM EVERY OTHER PROCESS
C     MESSAGES CAN HAVE DIFFERENT SIZES AND DISPLACEMENTS
C     USING MPI
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'mpif.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION A2SEND(NASEND),A2RECV(NARECV)
      INTEGER NISEND(NGROUP),NIRECV(NGROUP)
      INTEGER NDSEND(NGROUP),NDRECV(NGROUP)
      INTEGER NASEND,NARECV,NGROUP


C     LOCAL DATA
C     ==========
      INTEGER IERROR


C     BEGIN
C     =====

C     =========================================================================

      CALL MPI_ALLTOALLV(A2SEND,NISEND,NDSEND,MPI_DOUBLE_PRECISION,
     +                   A2RECV,NIRECV,NDRECV,MPI_DOUBLE_PRECISION,
     +                   MPI_COMM_WORLD,IERROR)

C     =========================================================================


      RETURN
      END
