      SUBROUTINE PARTRB
 
C     *************************************************************************
C
C     PARTRB
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     06-JUN-2009:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     CARRIES OUT TRANSFER OF PARALLEL DATA
C     FOR DIFFUSIVE INITIALISATION OF TURBULENCE
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION PASEND(NREMAX),PARECV(NREMAX)
      INTEGER IRCELL,JCELL


C     BEGIN
C     =====

C     =========================================================================

C     EXCHANGE PARALLEL DATA
C     ----------------------

C     U VELOCITY COMPONENT
      DO IRCELL = 1,NRRCEL
        JCELL = NRRLOC(IRCELL)
        PASEND(IRCELL) = URUN(1,JCELL)
      ENDDO

      CALL P_A2AV(PASEND,NREMAX,N2SEND,NCSEND,
     +            PARECV,NREMAX,N2RECV,NCRECV,NPROC)

      DO IRCELL = 1,NRCELL
        JCELL = NRCLOC(IRCELL)
        URUN(1,JCELL) = PARECV(IRCELL)
      ENDDO

C     V VELOCITY COMPONENT
      DO IRCELL = 1,NRRCEL
        JCELL = NRRLOC(IRCELL)
        PASEND(IRCELL) = URUN(2,JCELL)
      ENDDO

      CALL P_A2AV(PASEND,NREMAX,N2SEND,NCSEND,
     +            PARECV,NREMAX,N2RECV,NCRECV,NPROC)

      DO IRCELL = 1,NRCELL
        JCELL = NRCLOC(IRCELL)
        URUN(2,JCELL) = PARECV(IRCELL)
      ENDDO

C     W VELOCITY COMPONENT
      DO IRCELL = 1,NRRCEL
        JCELL = NRRLOC(IRCELL)
        PASEND(IRCELL) = URUN(3,JCELL)
      ENDDO

      CALL P_A2AV(PASEND,NREMAX,N2SEND,NCSEND,
     +            PARECV,NREMAX,N2RECV,NCRECV,NPROC)

      DO IRCELL = 1,NRCELL
        JCELL = NRCLOC(IRCELL)
        URUN(3,JCELL) = PARECV(IRCELL)
      ENDDO

C     =========================================================================


      RETURN
      END
