      SUBROUTINE RESVAR
 
C     *************************************************************************
C
C     RESVAR
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     14-AUG-2010:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     RESTORES THE RHS VARIABLES AFTER MESH ADAPTION
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER JCELL,JSPEC


C     BEGIN
C     =====

C     =========================================================================

C     RESTORE THE RHS VARIABLES
C     RESTORE THE SAVED-SOLUTION VALUES
C     REINITIALISE THE ERROR ARRAYS
      DO JCELL = 1,NCELL

        DRHS(JCELL) = DRUN(JCELL)
        DSAV(JCELL) = DRUN(JCELL)
        DERR(JCELL) = ZERO

        URHS(1,JCELL) = URUN(1,JCELL)
        USAV(1,JCELL) = URUN(1,JCELL)
        UERR(1,JCELL) = ZERO

        URHS(2,JCELL) = URUN(2,JCELL)
        USAV(2,JCELL) = URUN(2,JCELL)
        UERR(2,JCELL) = ZERO

        URHS(3,JCELL) = URUN(3,JCELL)
        USAV(3,JCELL) = URUN(3,JCELL)
        UERR(3,JCELL) = ZERO

        ERHS(JCELL) = ERUN(JCELL)
        ESAV(JCELL) = ERUN(JCELL)
        EERR(JCELL) = ZERO

        DO JSPEC = 1,NSPEC

          YRHS(JSPEC,JCELL) = YRUN(JSPEC,JCELL)
          YSAV(JSPEC,JCELL) = YRUN(JSPEC,JCELL)
          YERR(JSPEC,JCELL) = ZERO

        ENDDO

      ENDDO

C     =========================================================================


      RETURN
      END
