      SUBROUTINE SAVCON
 
C     *************************************************************************
C
C     SAVCON
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     16-MAR-2008:  CREATED
C     
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     SAVES THE CONSERVED VARIABLES
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER JCELL,ISPEC


C     BEGIN
C     =====

C     =========================================================================

C     RUN THROUGH ALL CELLS
C     INCLUDING HALO CELLS
      DO JCELL = 1, NCELL+NRCELL

C       =======================================================================

C       SAVE THE CONSERVED QUANTITIES
        DSOR(JCELL) = DRHS(JCELL)
        USOR(1,JCELL) = URHS(1,JCELL)
        USOR(2,JCELL) = URHS(2,JCELL)
        USOR(3,JCELL) = URHS(3,JCELL)
        ESOR(JCELL) = ERHS(JCELL)
        DO ISPEC = 1,NSPEC
          YSOR(ISPEC,JCELL) = YRHS(ISPEC,JCELL)
        ENDDO

C       =======================================================================

      ENDDO
C     END OF RUN THROUGH ALL CELLS

C     =========================================================================


      RETURN
      END
