      SUBROUTINE SORTRI(RRARAY,NIARAY,NASIZE,N2SORT)
 
C     *************************************************************************
C
C     SORTRI
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     14-OCT-2018:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     SORTS AN ARRAY OF REALS
C     AND MAKES THE SAME ARRANGEMENT IN ANOTHER ARRAYS OF INTEGERS
C     USING HEAPSORT
C
C     BASED ON NUMERICAL RECIPES pp229-232
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION RRARAY(NASIZE)
      INTEGER NIARAY(NASIZE)
      INTEGER NASIZE,N2SORT


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION R1RTMP
      DOUBLE PRECISION RRTMP1,RRTMP2
      INTEGER N1RTMP
      INTEGER IINDEX,JINDEX,JINDP1,KINDEX,LINDEX


C     BEGIN
C     =====

C     =========================================================================

C     PRELIMINARIES
C     -------------
      LINDEX = N2SORT/2 + 1

C     SORT ONLY IF ARRAY CONTAINS MORE THAN ONE ELEMENT
      IF(LINDEX.GT.1)THEN

C       =======================================================================

C       FORM THE HEAP
C       -------------
C       PICK A NEW ELEMENT FROM THE UPPER HALF OF THE HEAP
C                     I.E. FROM THE LOWER HALF OF THE ARRAY
1000    CONTINUE

          LINDEX = LINDEX - 1
          R1RTMP = RRARAY(LINDEX)
          N1RTMP = NIARAY(LINDEX)

          IINDEX = LINDEX
          JINDEX = LINDEX + LINDEX

C         LOOP TO SIFT THE NEW ELEMENT DOWN THE HEAP
1100      CONTINUE

            RRTMP1 = RRARAY(JINDEX)

C           FIND THE GREATER OF EACH PAIR OF EXISTING LOWER ELEMENTS
            IF(JINDEX.LT.N2SORT)THEN
              JINDP1 = JINDEX + 1
              RRTMP2 = RRARAY(JINDP1)
              IF(RRTMP1.LT.RRTMP2)THEN
                JINDEX = JINDP1
                RRTMP1 = RRTMP2
              ENDIF
            ENDIF

C           COMPARE THE NEW ELEMENT WITH THE EXISTING ELEMENT
            IF(R1RTMP.LT.RRTMP1)THEN
              RRARAY(IINDEX) = RRARAY(JINDEX)
              NIARAY(IINDEX) = NIARAY(JINDEX)
              IINDEX = JINDEX
              JINDEX = JINDEX + JINDEX
              IF(JINDEX.LE.N2SORT)GOTO 1100
            ENDIF

C         END OF LOOP 1100

C         PUT THE NEW ELEMENT INTO ITS SLOT
          RRARAY(IINDEX) = R1RTMP
          NIARAY(IINDEX) = N1RTMP

          IF(LINDEX.GT.1)GOTO 1000

C       END OF LOOP 1000

C       =======================================================================

C       SORT THE HEAP
C       -------------
        KINDEX = N2SORT

2000    CONTINUE

C         PICK THE HIGHEST UNSORTED ELEMENT OF THE ARRAY
          R1RTMP = RRARAY(KINDEX)
          N1RTMP = NIARAY(KINDEX)

C         MOVE THE CURRENT TOP-OF-THE-HEAP INTO THAT SLOT
          RRARAY(KINDEX) = RRARAY(1)
          NIARAY(KINDEX) = NIARAY(1)

C         DECREMENT INDEX OF HIGHEST UNSORTED ELEMENT
          KINDEX = KINDEX - 1

C         CHECK FOR LOWEST ELEMENT
          IF(KINDEX.GT.1)THEN

C           NOT THE LOWEST ELEMENT
            IINDEX = 1
            JINDEX = 2

C           LOOP TO SIFT THE ELEMENT DOWN THE HEAP
2100        CONTINUE

              RRTMP1 = RRARAY(JINDEX)

C             FIND THE GREATER OF EACH PAIR OF EXISTING LOWER ELEMENTS
              IF(JINDEX.LT.KINDEX)THEN
                JINDP1 = JINDEX + 1
                RRTMP2 = RRARAY(JINDP1)
                IF(RRTMP1.LT.RRTMP2)THEN
                  JINDEX = JINDP1
                  RRTMP1 = RRTMP2
                ENDIF
              ENDIF

C             COMPARE THE NEW ELEMENT WITH THE EXISTING ELEMENT
              IF(R1RTMP.LT.RRTMP1)THEN
                RRARAY(IINDEX) = RRARAY(JINDEX)
                NIARAY(IINDEX) = NIARAY(JINDEX)
                IINDEX = JINDEX
                JINDEX = JINDEX + JINDEX
                IF(JINDEX.LE.KINDEX)GOTO 2100
              ENDIF

C           END OF LOOP 2100

C           PUT THE NEW ELEMENT INTO ITS SLOT
            RRARAY(IINDEX) = R1RTMP
            NIARAY(IINDEX) = N1RTMP
            GOTO 2000

          ELSE

C           LOWEST ELEMENT
            RRARAY(1) = R1RTMP
            NIARAY(1) = N1RTMP

          ENDIF

C       END OF LOOP 2000

C       =======================================================================

      ENDIF
C     END OF SORT ONLY IF ARRAY CONTAINS MORE THAN ONE ELEMENT

C     =========================================================================


      RETURN
      END
