      SUBROUTINE STNREP
 
C     *************************************************************************
C
C     STNREP
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT
C
C     CHANGE RECORD
C     -------------
C     02-JUN-2016:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     REPORTS STENCIL DATA
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------

C     PARAMETERS
C     ==========
      INTEGER NCBSTN
      PARAMETER(NCBSTN = 20)


C     LOCAL DATA
C     ==========
      INTEGER MCRUN(NINDMX)
      INTEGER NCRSTN
      INTEGER JCELL,JRNCEL
      INTEGER JSTEN,NSTEN
      

C     BEGIN
C     =====

C     =========================================================================

C     UNIT NUMBER FOR OUTPUT
      NCRSTN = NCBSTN + IPROC


C     MORTON CODES
C     ============

C     HEADER
      WRITE(NCRSTN,*)'STNREP: proc ID, no of procs:'
      WRITE(NCRSTN,'(2I8)')IPROC,NPROC
      WRITE(NCRSTN,*)


C     INTERIOR CELLS
      WRITE(NCRSTN,*)'M-codes: interior cells'
      WRITE(NCRSTN,'(I10)')NCELL
      DO JCELL = 1,NCELL
        CALL MCRTRV(MCRUN,NMCODE,NSIZMX,JCELL)
        WRITE(NCRSTN,'(I8,2I12)')JCELL,(MCRUN(JSTEN),JSTEN=1,NINDMX)
      ENDDO
      WRITE(NCRSTN,*)

C     HALO CELLS
      WRITE(NCRSTN,*)'M-codes: halo cells'
      WRITE(NCRSTN,'(I8)')NCELHW-NCELL
      DO JCELL = NCELP1,NCELHW
        CALL MCRTRV(MCRUN,NMCODE,NSIZMX,JCELL)
        WRITE(NCRSTN,'(I8,2I12)')JCELL,(MCRUN(JSTEN),JSTEN=1,NINDMX)
      ENDDO
      WRITE(NCRSTN,*)


C     REPORT THE STENCIL DATA
C     =======================

C     INTERIOR CELLS
      WRITE(NCRSTN,*)'Stencils: interior cells'
      WRITE(NCRSTN,'(I8)')NCELL
      DO JCELL = 1,NCELL

        NSTEN = NOSSTN(JCELL)
        WRITE(NCRSTN,'(2I8)')JCELL,NSTEN
        WRITE(NCRSTN,'(40I8)')(NSSTEN(JSTEN,JCELL),JSTEN=1,NSTEN)
        WRITE(NCRSTN,'(6I8,I10)')(NXDOOR(JSTEN,JCELL),JSTEN=1,NFACMX),
     +                            NSCODE(JCELL)
        WRITE(NCRSTN,*)

      ENDDO

      WRITE(NCRSTN,*)'Halo cells'
      WRITE(NCRSTN,'(I8)')NCELHW-NCELL
      DO JCELL = NCELP1,NCELHW
        WRITE(NCRSTN,'(7I8,I20)')JCELL,
     +                          (NXDOOR(JSTEN,JCELL),JSTEN=1,NFACMX),
     +                           NSCODE(JCELL)
      ENDDO
      WRITE(NCRSTN,*)

      WRITE(NCRSTN,*)'Face neighbour cells'
      WRITE(NCRSTN,'(I8)')NRNCEL
      DO JRNCEL = 1, NRNCEL
        JCELL = NRNLOC(JRNCEL)
        NSTEN =  NOSSTN(JCELL)
        WRITE(NCRSTN,'(3I8)')JRNCEL,JCELL,NSTEN
        WRITE(NCRSTN,'(40I8)')(NSSTEN(JSTEN,JCELL),JSTEN=1,NSTEN)
      WRITE(NCRSTN,'(3I8)')NRNLOC(JRNCEL),NRNFAC(JRNCEL),NRNCOD(JRNCEL)
        WRITE(NCRSTN,*)
      ENDDO
      WRITE(NCRSTN,*)


C     REPORT THE PARTITION DATA
C     =========================

      WRITE(NCRSTN,*)'Partition data'
      DO JRNCEL = 1,NPROC
        WRITE(NCRSTN,'(3I8)')JRNCEL,N2SEND(JRNCEL),N2RECV(JRNCEL)
      ENDDO
      WRITE(NCRSTN,*)
      WRITE(NCRSTN,'(I8)')NRRCEL
      DO JRNCEL = 1,NRRCEL
        JCELL = NRRLOC(JRNCEL)
        WRITE(NCRSTN,'(2I8)')JRNCEL,JCELL
      ENDDO
      WRITE(NCRSTN,*)
      WRITE(NCRSTN,'(I8)')NRCELL
      DO JRNCEL = 1,NRCELL
        JCELL = NRCLOC(JRNCEL)
        WRITE(NCRSTN,'(2I8)')JRNCEL,JCELL
      ENDDO
      WRITE(NCRSTN,*)

C     =========================================================================


      RETURN
      END
